//*****************************************************************************
// FileName:	CS_Service.cs
// Author:		VL, HS, RS
// Created:		Nov-2003
//*****************************************************************************

using System;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Threading;


namespace CommunicationServer
{
	
	public class CommunicationServerService : System.ServiceProcess.ServiceBase
	{
		Thread th;
		public CommunicationServerService()
		{
			this.ServiceName = "CommunicationServer";
			this.CanStop = true;
			this.CanPauseAndContinue = true;
			this.AutoLog = true;

		}

		// The main entry point for the process
		static void Main()
		{
			System.ServiceProcess.ServiceBase[] ServicesToRun;				
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new CommunicationServerService() };

			System.ServiceProcess.ServiceBase.Run(ServicesToRun);
		}

		/// <summary>
		/// Set things in motion so your service can do its work.
		/// </summary>
		protected override void OnStart(string[] args)
		{
			// Create an instance of the CommunicationServer implementation
			// and start it in a thread.
			th = new Thread(new ThreadStart(Listener));
			th.Start();			
		}

		private void InitializeComponent()
		{
		
			this.ServiceName = "CommunicationServer";
		}
 
		// Stop this service.
		protected override void OnStop()
		{
			// Remove the listener thread, the SCM will indicate the service has stopped.
			th.Abort();
		}

		private void Listener()
		{
			CommunicationServer CS = new CommunicationServer();
			CS.StartListening();

		}
	}
}
