
'******************************************************************************
' FileName: MB_DB_Util.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************


Imports System
Imports System.IO
Imports System.Data
Imports System.Data.Common
Imports System.Data.SqlServerCe
Imports System.Collections
Imports System.Xml


Namespace MobileBiologist.PPC.Setup

    Public Class MB_DB_Util


        Public Sub New()

        End Sub

        Private Shared db As String = "\mb_db.sdf"

        Private Const strCreateSecurityTable = _
            "CREATE TABLE Security( " & _
            "username nvarchar(50) PRIMARY KEY, " & _
            "pwd nvarchar(50))"

        Private Const strCreateWaterSourceTable = _
            "CREATE TABLE WaterSource( " & _
            "id int PRIMARY KEY, " & _
            "name nvarchar(255), " & _
            "location nvarchar(255), " & _
            "latitude nvarchar(50), " & _
            "longitude nvarchar(50))"

        Private Const strCreateSampleTable = _
            "CREATE TABLE Sample( " & _
            "id int PRIMARY KEY, " & _
            "WaterSourceId int, " & _
            "SampleDate nvarchar(50), " & _
            "Temperature float, " & _
            "Ammonia float, " & _
            "Nitrate float, " & _
            "Nitrite float, " & _
            "pH float, " & _
            "Notes nvarchar(255))"



        Public Function GetDBName() As String
            Return db
        End Function
        Public Function GetStrConn() As String
            Return "Data Source=" & db & ";password=test" ';encrypt database=true" ';persist security info=false"
        End Function

        Public Function CheckInitialized() As Boolean
            Dim u As New MB_DB_Util
            If SqlCEHelper.DBExists(u.GetDBName) Then
                Return True
            Else
                Return False
            End If
        End Function

        Public Function InitializeDB() As Boolean
            Dim u As New MB_DB_Util
            If Not SqlCEHelper.DBExists(u.GetDBName) Then
                SqlCEHelper.CreateDB(u.GetStrConn)
            End If

            Try
                'create table security
                SqlCEHelper.ExecuteCommand _
                (u.GetStrConn, _
                strCreateSecurityTable)

                'create table water sources
                SqlCEHelper.ExecuteCommand _
                (Me.GetStrConn, _
                strCreateWaterSourceTable)

                'create table samples
                SqlCEHelper.ExecuteCommand _
                (Me.GetStrConn, _
                strCreateSampleTable)

            Catch ex As Exception
                SqlCEHelper.DeleteDB(Me.GetStrConn)
                Return False
            End Try

            Return True
        End Function

    End Class


End Namespace
