
'******************************************************************************
' FileName: Sample.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports MobileBiologist.PPC.DataAccessObjects

Namespace MobileBiologist.PPC.BusinessObjects

    Public Class Sample
        Private mid As Integer
        Private mWaterSourceId As Integer
        Private mSampleDate As String
        Private mTemperature As String = "0"
        Private mpH As String = "0"
        Private mAmmonia As String = "0"
        Private mNitrate As String = "0"
        Private mNitrite As String = "0"
        Private mNotes As String = ""
        Private mWaterSourceName = ""

#Region "Properties"
        Public Property Id() As Integer
            Get
                Return mid
            End Get
            Set(ByVal Value As Integer)
                mid = Value
            End Set
        End Property
        Public Property WaterSourceId() As Integer
            Get
                Return mWaterSourceId
            End Get
            Set(ByVal Value As Integer)
                mWaterSourceId = Value
            End Set
        End Property
        Public Property SampleDate() As String
            Get
                Return mSampleDate
            End Get
            Set(ByVal Value As String)
                mSampleDate = Value
            End Set
        End Property
        Public Property Temperature() As String
            Get
                Return mTemperature
            End Get
            Set(ByVal Value As String)
                mTemperature = Value
            End Set
        End Property

        Public Property pH() As String
            Get
                Return mpH
            End Get
            Set(ByVal Value As String)
                mpH = Value
            End Set
        End Property
        Public Property Ammonia() As String
            Get
                Return mAmmonia
            End Get
            Set(ByVal Value As String)
                mAmmonia = Value
            End Set
        End Property
        Public Property Nitrate() As String
            Get
                Return mNitrate
            End Get
            Set(ByVal Value As String)
                mNitrate = Value
            End Set
        End Property
        Public Property Nitrite() As String
            Get
                Return mNitrite
            End Get
            Set(ByVal Value As String)
                mNitrite = Value
            End Set
        End Property
        Public Property Notes() As String
            Get
                Return mNotes
            End Get
            Set(ByVal Value As String)
                mNotes = Value
            End Set
        End Property
        Public ReadOnly Property WaterSourceName()
            Get
                Return mWaterSourceName
            End Get

        End Property
        Public ReadOnly Property DisplayName()
            Get
                Return mWaterSourceName & " - " & mSampleDate
            End Get
        End Property
#End Region

#Region "Constructors"
        Public Sub New()

        End Sub
        Public Sub New(ByVal visitId As Integer)
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow
            Dim u As New Util


            mid = visitId

            strSQL = "SELECT * FROM Sample WHERE Id=" & mid
            ds = SqlCEHelper.ExecuteDataset(u.GetStrConn, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then Return

            r = ds.Tables(0).Rows(0)

            If Not r("WaterSourceId") Is DBNull.Value Then
                mWaterSourceId = r("WaterSourceId")
            End If
            If Not r("SampleDate") Is DBNull.Value Then
                mSampleDate = r("SampleDate")
            End If
            If Not r("Temperature") Is DBNull.Value Then
                mTemperature = r("Temperature")
            End If
            If Not r("pH") Is DBNull.Value Then
                mpH = Format(r("pH"), "0.0")
            End If
            If Not r("Ammonia") Is DBNull.Value Then
                mAmmonia = Format(r("Ammonia"), "0.0")
            End If
            If Not r("Nitrate") Is DBNull.Value Then
                mNitrate = r("Nitrate")
            End If
            If Not r("Nitrite") Is DBNull.Value Then
                mNitrite = Format(r("Nitrite"), "0.0")
            End If
            If Not r("Notes") Is DBNull.Value Then
                mNotes = r("Notes")
            End If

            strSQL = "SELECT Name from WaterSource where Id=" & mWaterSourceId
            ds = SqlCEHelper.ExecuteDataset(u.GetStrConn, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then Return

            r = ds.Tables(0).Rows(0)
            If Not r("Name") Is DBNull.Value Then
                mWaterSourceName = r("Name")
            End If

        End Sub
#End Region
#Region "Public Methods"

        Public Function AddSamplesToServer(ByVal sampleXML As String) As Boolean
            Dim proxy As New Server.MB_WS
            Dim u As New Util
            proxy.Url = u.GetURL
            Return proxy.AddAllSamples(sampleXML)
        End Function
        Public Function GetSampleListByLocation(ByVal waterSourceId As Integer) As ArrayList
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow
            Dim u As New Util

            Dim sampleArray As New ArrayList

            strSQL = "SELECT * FROM Sample where WaterSourceId=" & waterSourceId
            ds = SqlCEHelper.ExecuteDataset(u.GetStrConn, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return sampleArray
            End If

            For Each r In ds.Tables(0).Rows
                Dim s As New Sample(r("Id"))
                sampleArray.Add(s)
            Next r
            Return sampleArray

        End Function



        Public Function Delete() As Boolean
            Try
                Dim strSQL As String
                Dim ds As DataSet
                Dim r As DataRow
                Dim u As New Util

                strSQL = "Delete FROM Sample " & _
                    "WHERE Id=" & mid

                Return 0 < SqlCEHelper.ExecuteCommand(u.GetStrConn, strSQL)
            Catch ex As Exception
                Throw ex
            End Try

        End Function


        Public Function Update() As Boolean
            Dim result As Integer
            Dim strSQL As String
            Dim u As New Util

            strSQL = "UPDATE SAMPLE SET " & _
            "SampleDate='" & mSampleDate & "', " & _
            "Temperature=" & mTemperature & ", " & _
            "ph=" & mpH & ", " & _
            "Ammonia=" & mAmmonia & ", " & _
            "Nitrate=" & mNitrate & ", " & _
            "Nitrite=" & mNitrite & ", " & _
            "Notes='" & mNotes & "' " & _
            "WHERE Id=" & mid

            SqlCEHelper.ExecuteCommand _
            (u.GetStrConn, strSQL)


            Return True
        End Function


        Public Function Insert() As Boolean
            Dim result As Integer
            Dim strSQL As String
            Dim u As New Util


            strSQL = "INSERT INTO Sample " & _
                "(Id, WaterSourceId, SampleDate, Temperature, " & _
                "pH, Ammonia, " & _
                "Nitrate, Nitrite, Notes) " & _
                "VALUES (" & _
                "" & mid & ", " & _
                "" & mWaterSourceId & ", " & _
                "'" & mSampleDate & "', " & _
                "" & mTemperature & ", " & _
                "" & mpH & ", " & _
                "" & mAmmonia & ", " & _
                "" & mNitrate & ", " & _
                "" & mNitrite & ", " & _
                "'" & mNotes & "')"

            SqlCEHelper.ExecuteCommand _
            (u.GetStrConn, strSQL)

            Return True

        End Function

        Public Function GetTempId() As Integer
            Dim result As Integer
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow
            Dim u As New Util

            'get temp id
            strSQL = "SELECT MIN(Id) as TempId from Sample"
            ds = SqlCEHelper.ExecuteDataset _
            (u.GetStrConn, strSQL)

            r = ds.Tables(0).Rows(0)
            If r("TempId") Is DBNull.Value Then
                result = -1
            Else
                result = r("TempId") - 1
                If result >= 0 Then result = -1
            End If
            Return result
        End Function

        Public Function GetNewSamples()
            Dim result As Integer
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow
            Dim arrSamples As New ArrayList
            Dim u As New Util

            strSQL = "SELECT Id FROM Sample WHERE Id<0"
            ds = SqlCEHelper.ExecuteDataset _
            (u.GetStrConn, strSQL)

            For Each r In ds.Tables(0).Rows
                arrSamples.Add(New Sample(r("Id")))
            Next
            Return arrSamples
        End Function
#End Region
    End Class
End Namespace
