
'******************************************************************************
' FileName: WaterSource.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports MobileBiologist.PPC.DataAccessObjects

Namespace MobileBiologist.PPC.BusinessObjects


    Public Class WaterSource
        Private mId As Integer = 0
        Private mName As String = String.Empty
        Private mLocation As String = String.Empty
        Private mLatitude As String = String.Empty
        Private mLongitude As String = String.Empty
        Private mSamples As ArrayList

#Region "Properties"

        Public Property Id() As Integer
            Get
                Return mId
            End Get
            Set(ByVal Value As Integer)
                mId = Value
            End Set
        End Property
        Public Property Name() As String
            Get
                Return mName
            End Get
            Set(ByVal Value As String)
                mName = Value
            End Set
        End Property
        Public Property Location() As String
            Get
                Return mLocation
            End Get
            Set(ByVal Value As String)
                mLocation = Value
            End Set
        End Property
        Public Property Latitude() As String
            Get
                Return mLatitude
            End Get
            Set(ByVal Value As String)
                mLatitude = Value
            End Set
        End Property
        Public Property Longitude() As String
            Get
                Return mLongitude
            End Get
            Set(ByVal Value As String)
                mLongitude = Value
            End Set
        End Property
        Public Property Samples() As ArrayList
            Get
                Return mSamples
            End Get
            Set(ByVal Value As ArrayList)
                mSamples = Value
            End Set
        End Property
#End Region

#Region "Constructors"
        Public Sub New()

        End Sub
        Public Sub New(ByVal id As Integer)
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow
            Dim u As New Util


            mId = id

            strSQL = "SELECT * FROM WaterSource WHERE Id=" & mId
            ds = SqlCEHelper.ExecuteDataset _
            (u.GetStrConn, strSQL)

            If ds.Tables(0).Rows.Count = 0 Then Return

            r = ds.Tables(0).Rows(0)

            If Not r("Name") Is DBNull.Value Then
                mName = r("Name")
            End If
            If Not r("Location") Is DBNull.Value Then
                mLocation = r("Location")
            End If
            If Not r("Latitude") Is DBNull.Value Then
                mLatitude = r("Latitude")
            End If
            If Not r("Longitude") Is DBNull.Value Then
                mLongitude = r("Longitude")
            End If

            'get the samples
            strSQL = "select * from Sample where WaterSourceId=" & mId
            ds = SqlCEHelper.ExecuteDataset _
            (u.GetStrConn, strSQL)

            mSamples = New ArrayList
            If ds.Tables(0).Rows.Count = 0 Then Return
            For Each r In ds.Tables(0).Rows
                mSamples.Add(New Sample(r("Id")))
            Next


        End Sub
#End Region

#Region "Public Methods"

        Public Function GetRemoteWaterSourceXML() As String
            Dim proxy As New Server.MB_WS
            Dim u As New Util
            proxy.Url = u.GetURL
            Return proxy.GetWaterSources
        End Function
        Public Function GetWaterSourceList() As ArrayList
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow
            Dim u As New Util

            Dim wsArray As New ArrayList


            strSQL = "SELECT * FROM WaterSource"
            ds = SqlCEHelper.ExecuteDataset _
            (u.GetStrConn, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return wsArray
            End If

            For Each r In ds.Tables(0).Rows
                Dim ws As New WaterSource(r("Id"))
                wsArray.Add(ws)
            Next r
            Return wsArray

        End Function




        Public Function Insert() As Boolean
            Dim result As Integer
            Dim strSQL As String
            Dim u As New Util

            strSQL = "INSERT INTO WaterSource " & _
                "(Id, Name, Location, Latitude, " & _
                "Longitude) " & _
                "VALUES (" & _
                "" & mId & ", " & _
                "'" & mName & "', " & _
                "'" & mLocation & "', " & _
                "'" & mLatitude & "', " & _
                "'" & mLongitude & "')"

            SqlCEHelper.ExecuteCommand _
            (u.GetStrConn, strSQL)

            Dim s As Sample
            For Each s In mSamples
                s.Insert()
            Next
            Return True

        End Function

#End Region


    End Class

End Namespace
