
'******************************************************************************
' FileName: SQLCEHelper.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports System
Imports System.IO
Imports System.Data
Imports System.Data.Common
Imports System.Data.SqlServerCe
Imports System.Collections


Namespace MobileBiologist.PPC.DataAccessObjects


    Public NotInheritable Class SqlCEHelper

        Private Sub New()
        End Sub 'New

        Public Shared Function DBExists _
        (ByVal db As String) As Boolean
            Try
                If File.Exists(db) Then
                    Return True
                Else
                End If
            Catch ex As Exception
                Throw ex
            End Try
        End Function

        Public Shared Function CreateDB _
        (ByVal db As String) As Boolean

            Dim sqlEngine As SqlCeEngine
            Dim cn As SqlCeConnection
            Dim cmd As SqlCeCommand

            Try
                sqlEngine = New SqlCeEngine(db)
                sqlEngine.CreateDatabase()
                sqlEngine.Dispose()
            Catch ex As SqlCeException
                Throw New Exception(ex.Errors(0).Message)
            End Try

        End Function

        Public Shared Function DeleteDB _
        (ByVal db As String) As Boolean
            File.Delete(db)
        End Function

        Public Shared Function ExecuteCommand _
            (ByVal strConn As String, _
            ByVal strSQL As String)

            Dim cn As SqlCeConnection
            Dim cmd As SqlCeCommand

            Try
                cmd = New SqlCeCommand
                cn = New SqlCeConnection(strConn)
                cn.Open()
                cmd.Connection = cn
                cmd.CommandText = strSQL
                cmd.ExecuteNonQuery()

                cn.Close()
            Catch ex As SqlCeException
                Throw New Exception(ex.Errors(0).Message)
            End Try
        End Function

        Public Shared Function ExecuteDataset _
                (ByVal strConn As String, _
                ByVal strSQL As String) As DataSet

            Dim cn As SqlCeConnection
            Dim cmd As SqlCeCommand
            Dim ds As DataSet
            Dim da As SqlCeDataAdapter

            Try
                cmd = New SqlCeCommand
                cn = New SqlCeConnection(strConn)
                ds = New DataSet

                cn.Open()
                da = New SqlCeDataAdapter(strSQL, cn)
                da.Fill(ds)

                cn.Close()
                Return ds
            Catch ex As SqlCeException
                Throw New Exception(ex.Errors(0).Message)
            End Try

        End Function

        Public Shared Function ExecuteScalar _
    (ByVal strConn As String, _
    ByVal strSQL As String) As Integer

            Dim cn As SqlCeConnection
            Dim cmd As SqlCeCommand
            Dim result As Integer
            Try
                cmd = New SqlCeCommand
                cn = New SqlCeConnection(strConn)
                cn.Open()
                cmd.Connection = cn
                cmd.CommandText = strSQL

                result = cmd.ExecuteScalar()

                cn.Close()
            Catch ex As SqlCeException
                Throw New Exception(ex.Errors(0).Message)
            End Try
        End Function

    End Class
End Namespace