
'******************************************************************************
' FileName: frmDownload.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports System.Xml
Imports MobileBiologist.PPC.BusinessObjects

Namespace MobileBiologist.PPC.WinForms

    Public Class frmDownload
        Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Windows Form Designer.
            InitializeComponent()

            'Add any initialization after the InitializeComponent() call

        End Sub

        'Form overrides dispose to clean up the component list.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            MyBase.Dispose(disposing)
        End Sub

        'NOTE: The following procedure is required by the Windows Form Designer
        'It can be modified using the Windows Form Designer.  
        'Do not modify it using the code editor.
        Friend WithEvents cmdSave As System.Windows.Forms.Button
        Friend WithEvents cmdCancel As System.Windows.Forms.Button
        Friend WithEvents lstSources As System.Windows.Forms.ListBox
        Friend WithEvents mnuMain As System.Windows.Forms.MainMenu
        Friend WithEvents mnuItemFile As System.Windows.Forms.MenuItem
        Friend WithEvents mnuItemFileExit As System.Windows.Forms.MenuItem
        Friend WithEvents pnlTop2 As System.Windows.Forms.Panel
        Friend WithEvents pnlTop1 As System.Windows.Forms.Panel
        Friend WithEvents Label1 As System.Windows.Forms.Label
        Private Sub InitializeComponent()
            Me.lstSources = New System.Windows.Forms.ListBox
            Me.cmdSave = New System.Windows.Forms.Button
            Me.cmdCancel = New System.Windows.Forms.Button
            Me.mnuMain = New System.Windows.Forms.MainMenu
            Me.mnuItemFile = New System.Windows.Forms.MenuItem
            Me.mnuItemFileExit = New System.Windows.Forms.MenuItem
            Me.pnlTop2 = New System.Windows.Forms.Panel
            Me.pnlTop1 = New System.Windows.Forms.Panel
            Me.Label1 = New System.Windows.Forms.Label
            '
            'lstSources
            '
            Me.lstSources.Location = New System.Drawing.Point(16, 72)
            Me.lstSources.Size = New System.Drawing.Size(200, 142)
            '
            'cmdSave
            '
            Me.cmdSave.Location = New System.Drawing.Point(64, 240)
            Me.cmdSave.Text = "Download"
            '
            'cmdCancel
            '
            Me.cmdCancel.Location = New System.Drawing.Point(144, 240)
            Me.cmdCancel.Text = "Cancel"
            '
            'mnuMain
            '
            Me.mnuMain.MenuItems.Add(Me.mnuItemFile)
            '
            'mnuItemFile
            '
            Me.mnuItemFile.MenuItems.Add(Me.mnuItemFileExit)
            Me.mnuItemFile.Text = "File"
            '
            'mnuItemFileExit
            '
            Me.mnuItemFileExit.Text = "Exit"
            '
            'pnlTop2
            '
            Me.pnlTop2.BackColor = System.Drawing.Color.DarkSlateBlue
            Me.pnlTop2.Location = New System.Drawing.Point(0, 16)
            Me.pnlTop2.Size = New System.Drawing.Size(248, 16)
            '
            'pnlTop1
            '
            Me.pnlTop1.BackColor = System.Drawing.Color.Black
            Me.pnlTop1.Size = New System.Drawing.Size(248, 16)
            '
            'Label1
            '
            Me.Label1.Location = New System.Drawing.Point(8, 48)
            Me.Label1.Size = New System.Drawing.Size(100, 16)
            Me.Label1.Text = "Download"
            '
            'frmDownload
            '
            Me.Controls.Add(Me.Label1)
            Me.Controls.Add(Me.pnlTop2)
            Me.Controls.Add(Me.pnlTop1)
            Me.Controls.Add(Me.cmdCancel)
            Me.Controls.Add(Me.cmdSave)
            Me.Controls.Add(Me.lstSources)
            Me.MaximizeBox = False
            Me.Menu = Me.mnuMain
            Me.MinimizeBox = False
            Me.Text = "Mobile Biologist"

        End Sub

#End Region

        Private firstForm As Form
        Private xmlWaterSources As String

        Private arrWaterSources As ArrayList



        Public Sub New(ByVal firstForm As Form)
            Me.firstForm = firstForm
            InitializeComponent()
        End Sub
        Private Sub frmListLocations_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                Dim ws As New WaterSource
                Dim arrSamples As ArrayList
                Dim s As Sample
                Dim objDom As New XmlDocument
                Dim objNodeList As XmlNodeList
                Dim objNode As XmlNode
                Dim reader As XmlNodeReader

                Dim id As Integer
                Dim name As String
                Dim lvi As ListViewItem
                Dim lvsi As ListViewItem.ListViewSubItem

                xmlWaterSources = ws.GetRemoteWaterSourceXML

                objDom.LoadXml(xmlWaterSources)
                reader = New XmlNodeReader(objDom.DocumentElement)
                arrWaterSources = New ArrayList

                While reader.Read
                    Select Case reader.NodeType
                        Case XmlNodeType.Element
                            Select Case reader.Name
                                Case "WaterSource"
                                    arrSamples = New ArrayList
                                    ws = New WaterSource
                                    ws.Id = reader.GetAttribute("Id")

                                Case "Name"
                                    ws.Name = reader.ReadString
                                Case "Location"
                                    ws.Location = reader.ReadString
                                Case "Latitude"
                                    ws.Latitude = reader.ReadString
                                Case "Longitude"
                                    ws.Longitude = reader.ReadString
                                Case "Sample"
                                    s = New Sample
                                    s.Id = reader.GetAttribute("Id")
                                Case "WaterSourceId"
                                    s.WaterSourceId = reader.ReadString
                                Case "SampleDate"
                                    s.SampleDate = reader.ReadString
                                Case "Temperature"
                                    s.Temperature = reader.ReadString
                                Case "pH"
                                    s.pH = reader.ReadString
                                Case "Ammonia"
                                    s.Ammonia = reader.ReadString
                                Case "Nitrate"
                                    s.Nitrate = reader.ReadString
                                Case "Nitrite"
                                    s.Nitrite = reader.ReadString
                                Case "Notes"
                                    s.Notes = reader.ReadString
                            End Select
                        Case XmlNodeType.EndElement
                            If reader.Name = "Sample" Then
                                arrSamples.Add(s)
                            End If
                            If reader.Name = "WaterSource" Then
                                'add the samples
                                ws.Samples = arrSamples
                                'add to the collection
                                arrWaterSources.Add(ws)
                                'end the water source, add to list
                                '                                lstSources.Items.Add(ws.Id & "-" & ws.Name)
                            End If
                    End Select
                End While
                lstSources.DataSource = arrWaterSources
                lstSources.DisplayMember = "Name"
                lstSources.ValueMember = "Id"

                Cursor.Current = Cursors.Default
                firstForm.Hide()
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End Sub


        Private Sub cmdSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSave.Click
            If MsgBox("Are you sure you want to save this data?", MsgBoxStyle.OKCancel) = MsgBoxResult.OK Then
                'save the data locally
                'delete the old data first
                Dim u As New Util
                u.CleanDatabase()

                Dim ws As WaterSource
                For Each ws In arrWaterSources
                    ws.Insert()
                Next
                Try

                Catch ex As Exception

                End Try
                Dim f As New frmTasks(Me)
                f.Show()
            End If

        End Sub

        Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
            Dim f As New frmTasks(Me)
            f.ShowDialog()
        End Sub

        Private Sub mnuItemFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuItemFileExit.Click
            Application.Exit()
        End Sub


        
    End Class
End Namespace
