
'******************************************************************************
' FileName: frmUpload.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports MobileBiologist.PPC.BusinessObjects
Imports System.Xml

Namespace MobileBiologist.PPC.WinForms

    Public Class frmUpload
        Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Windows Form Designer.
            InitializeComponent()

            'Add any initialization after the InitializeComponent() call

        End Sub

        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            MyBase.Dispose(disposing)
        End Sub

        'NOTE: The following procedure is required by the Windows Form Designer
        'It can be modified using the Windows Form Designer.  
        'Do not modify it using the code editor.
        Friend WithEvents pnlTop2 As System.Windows.Forms.Panel
        Friend WithEvents mnuMain As System.Windows.Forms.MainMenu
        Friend WithEvents mnuItemFile As System.Windows.Forms.MenuItem
        Friend WithEvents mnuItemFileExit As System.Windows.Forms.MenuItem
        Friend WithEvents pnlTop1 As System.Windows.Forms.Panel
        Friend WithEvents lstNewSamples As System.Windows.Forms.ListBox
        Friend WithEvents Label1 As System.Windows.Forms.Label
        Friend WithEvents cmdUpload As System.Windows.Forms.Button
        Friend WithEvents cmdCancel As System.Windows.Forms.Button
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.pnlTop2 = New System.Windows.Forms.Panel
            Me.mnuMain = New System.Windows.Forms.MainMenu
            Me.mnuItemFile = New System.Windows.Forms.MenuItem
            Me.mnuItemFileExit = New System.Windows.Forms.MenuItem
            Me.pnlTop1 = New System.Windows.Forms.Panel
            Me.lstNewSamples = New System.Windows.Forms.ListBox
            Me.Label1 = New System.Windows.Forms.Label
            Me.cmdUpload = New System.Windows.Forms.Button
            Me.cmdCancel = New System.Windows.Forms.Button
            '
            'pnlTop2
            '
            Me.pnlTop2.BackColor = System.Drawing.Color.DarkSlateBlue
            Me.pnlTop2.Location = New System.Drawing.Point(0, 16)
            Me.pnlTop2.Size = New System.Drawing.Size(248, 16)
            '
            'mnuMain
            '
            Me.mnuMain.MenuItems.Add(Me.mnuItemFile)
            '
            'mnuItemFile
            '
            Me.mnuItemFile.MenuItems.Add(Me.mnuItemFileExit)
            Me.mnuItemFile.Text = "File"
            '
            'mnuItemFileExit
            '
            Me.mnuItemFileExit.Text = "Exit"
            '
            'pnlTop1
            '
            Me.pnlTop1.BackColor = System.Drawing.Color.Black
            Me.pnlTop1.Size = New System.Drawing.Size(248, 16)
            '
            'lstNewSamples
            '
            Me.lstNewSamples.Location = New System.Drawing.Point(8, 72)
            Me.lstNewSamples.Size = New System.Drawing.Size(216, 142)
            '
            'Label1
            '
            Me.Label1.Location = New System.Drawing.Point(8, 48)
            Me.Label1.Text = "New Samples"
            '
            'cmdUpload
            '
            Me.cmdUpload.Location = New System.Drawing.Point(72, 232)
            Me.cmdUpload.Text = "Upload"
            '
            'cmdCancel
            '
            Me.cmdCancel.Location = New System.Drawing.Point(152, 232)
            Me.cmdCancel.Text = "Cancel"
            '
            'frmUpload
            '
            Me.Controls.Add(Me.cmdCancel)
            Me.Controls.Add(Me.cmdUpload)
            Me.Controls.Add(Me.Label1)
            Me.Controls.Add(Me.lstNewSamples)
            Me.Controls.Add(Me.pnlTop1)
            Me.Controls.Add(Me.pnlTop2)
            Me.MaximizeBox = False
            Me.Menu = Me.mnuMain
            Me.MinimizeBox = False
            Me.Text = "Mobile Biologist"

        End Sub

#End Region

        Private firstForm As Form

        Private s As Sample
        Private arrSamples As ArrayList

        Public Sub New(ByVal firstForm As Form)
            MyBase.new()
            Me.firstForm = firstForm
            InitializeComponent()
        End Sub
        Private Sub frmUpload_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            'get all the new samples
            s = New Sample
            arrSamples = s.GetNewSamples
            lstNewSamples.DataSource = arrSamples
            lstNewSamples.ValueMember = "Id"
            lstNewSamples.DisplayMember = "DisplayName"

            Cursor.Current = Cursors.Default
            firstForm.Hide()
        End Sub

        Private Sub mnuItemFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuItemFileExit.Click
            Application.Exit()
        End Sub

        Private Sub cmdUpload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdUpload.Click
            If MsgBox("Are you sure you want to upload this data?", MsgBoxStyle.OKCancel) Then
                'upload the changes
                'create an xml document with each samples information
                'and call the web service
                Dim ws As New WaterSource

                Dim strXML As String
                Dim result As Boolean
                Dim fileName As String

                Dim objXMLDoc As XmlDocument
                Dim objWSNode As XmlNode
                Dim objSampleNode As XmlNode
                Dim objNewNode As XmlNode
                Dim objRootDocNode As XmlNode
                Dim reader As XmlNodeReader
                Dim objXMLAttribute As XmlAttribute

                Dim arrWaterSources As ArrayList

                objXMLDoc = New XmlDocument
                fileName = "\Program Files\MB_PPC\Samples.xml"
                objXMLDoc.Load(fileName)

                objRootDocNode = objXMLDoc.DocumentElement
                For Each s In arrSamples
                    objSampleNode = objXMLDoc.CreateElement("Sample")
                    objXMLAttribute = objXMLDoc.CreateAttribute("Id")
                    objXMLAttribute.Value = s.Id
                    objSampleNode.Attributes.Append(objXMLAttribute)
                    objSampleNode = objRootDocNode.AppendChild(objSampleNode)

                    AddElement(objXMLDoc, objSampleNode, objNewNode, "WaterSourceId", s.WaterSourceId)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "SampleDate", s.SampleDate)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "Temperature", s.Temperature)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "pH", s.pH)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "Ammonia", s.Ammonia)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "Nitrate", s.Nitrate)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "Nitrite", s.Nitrite)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "Notes", s.Notes)

                Next
                strXML = objXMLDoc.InnerXml

                s = New Sample
                result = s.AddSamplesToServer(strXML)
                If result = True Then
                    MsgBox("Data was saved. Downloading new data...", MsgBoxStyle.OKOnly)
                    'download the new data

                    strXML = ws.GetRemoteWaterSourceXML()
                    objXMLDoc.LoadXml(strXML)
                    reader = New XmlNodeReader(objXMLDoc.DocumentElement)
                    arrWaterSources = New ArrayList

                    While reader.Read
                        Select Case reader.NodeType
                            Case XmlNodeType.Element
                                Select Case reader.Name
                                    Case "WaterSource"
                                        arrSamples = New ArrayList
                                        ws = New WaterSource
                                        ws.Id = reader.GetAttribute("Id")

                                    Case "Name"
                                        ws.Name = reader.ReadString
                                    Case "Location"
                                        ws.Location = reader.ReadString
                                    Case "Latitude"
                                        ws.Latitude = reader.ReadString
                                    Case "Longitude"
                                        ws.Longitude = reader.ReadString
                                    Case "Sample"
                                        s = New Sample
                                        s.Id = reader.GetAttribute("Id")
                                    Case "WaterSourceId"
                                        s.WaterSourceId = reader.ReadString
                                    Case "SampleDate"
                                        s.SampleDate = reader.ReadString
                                    Case "Temperature"
                                        s.Temperature = reader.ReadString
                                    Case "pH"
                                        s.pH = reader.ReadString
                                    Case "Ammonia"
                                        s.Ammonia = reader.ReadString
                                    Case "Nitrate"
                                        s.Nitrate = reader.ReadString
                                    Case "Nitrite"
                                        s.Nitrite = reader.ReadString
                                    Case "Notes"
                                        s.Notes = reader.ReadString
                                End Select
                            Case XmlNodeType.EndElement
                                If reader.Name = "Sample" Then
                                    arrSamples.Add(s)
                                End If
                                If reader.Name = "WaterSource" Then
                                    'add the samples
                                    ws.Samples = arrSamples
                                    'add to the collection
                                    arrWaterSources.Add(ws)
                                    'end the water source, add to list
                                    '                                lstSources.Items.Add(ws.Id & "-" & ws.Name)
                                End If
                        End Select
                    End While
                    Cursor.Current = Cursors.WaitCursor

                    Dim u As New Util
                    u.CleanDatabase()

                    For Each ws In arrWaterSources
                        ws.Insert()
                    Next

                    Dim f As New frmTasks(Me)
                    f.ShowDialog()

                Else
                    MsgBox("Error saving data")
                End If

            End If
        End Sub

        Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
            Cursor.Current = Cursors.WaitCursor
            Dim f As New frmTasks(Me)
            f.ShowDialog()

        End Sub

        Private Function AddElement(ByRef objXMLDoc As XmlDocument, _
            ByRef objParentNode As XmlNode, _
            ByRef objNewNode As XmlNode, _
          ByVal strName As String, _
            ByVal strValue As String)

            objNewNode = objXMLDoc.CreateElement(strName)
            objNewNode = objParentNode.AppendChild(objNewNode)
            objNewNode.AppendChild(objXMLDoc.CreateTextNode(strValue))


        End Function

     
    End Class
End Namespace
