
'******************************************************************************
' FileName: CustomPrincipal.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports System
Imports System.Security.Principal

Namespace MobileBiologist.BusinessObjects

    Public Class CustomPrincipal
        Implements IPrincipal

        Private mId As Integer
        Private mRoleName As String = [String].Empty
        Private mUsername As String ' username/login id
        Private mName As String 'name

        ' Required to implement the IPrincipal interface.
        Protected mIdentity As IIdentity

        Public Sub New()
        End Sub 'New

        Public Sub New(ByVal identity As IIdentity, ByVal id As Integer, ByVal roleName As String, ByVal name As String, ByVal userName As String)
            mIdentity = identity
            mId = id
            mRoleName = roleName
            mName = name
            mUsername = userName
        End Sub 'New

        ' IIdentity property used to retrieve the Identity object attached to
        ' this principal.

        Public ReadOnly Property Identity() As IIdentity Implements IPrincipal.Identity
            Get
                Return mIdentity
            End Get
        End Property

        ' The user's ID, created when the user was inserted into the database

        Public Property Id() As Integer
            Get
                Return mId
            End Get
            Set(ByVal Value As Integer)
                mId = Value
            End Set
        End Property

        Public Property UserName() As String
            Get
                Return mUsername
            End Get
            Set(ByVal Value As String)
                mUsername = Value
            End Set
        End Property

        ' The user's role

        Public Property RoleName() As String
            Get
                Return mRoleName
            End Get
            Set(ByVal Value As String)
                mRoleName = Value
            End Set
        End Property

        ' The user's name (First and Last name)

        Public Property Name() As String
            Get
                Return mName
            End Get
            Set(ByVal Value As String)
                mName = Value
            End Set
        End Property

        Public Function IsInRole(ByVal role As String) As Boolean Implements IPrincipal.IsInRole
            If UCase(mRoleName) = UCase(role) Then
                Return True
            End If
            Return False
        End Function 'IsInRole
    End Class 'CustomPrincipal
End Namespace