
'******************************************************************************
' FileName: MBRole.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports MobileBiologist.DataAccessObjects
Namespace MobileBiologist.BusinessObjects

    Public Class MBRole
        Private mId As Integer
        Private mName As String
        Private mDesc As String

#Region "Properties"
        Public Property Id() As Integer
            Get
                Return mId
            End Get
            Set(ByVal Value As Integer)
                mId = Value
            End Set
        End Property
        Public Property Name() As String
            Get
                Return mName
            End Get
            Set(ByVal Value As String)
                mName = Value
            End Set
        End Property
        Public Property Description() As String
            Get
                Return mDesc
            End Get
            Set(ByVal Value As String)
                mDesc = Value
            End Set
        End Property
#End Region

#Region "Constructors"
        Public Sub New()

        End Sub
        Public Sub New(ByVal id As Integer)
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow


            mId = id

            strSQL = "SELECT * FROM MBRole WHERE Id=" & mId
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then Return

            r = ds.Tables(0).Rows(0)

            If Not r("Name") Is DBNull.Value Then
                mName = r("Name")
            End If
            If Not r("Description") Is DBNull.Value Then
                mDesc = r("Description")
            End If

        End Sub
#End Region

#Region "Public Methods"
        Public Function GetRoleList() As ArrayList
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            Dim roleArray As New ArrayList

            strSQL = "SELECT * FROM MBRole"
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return roleArray
            End If

            For Each r In ds.Tables(0).Rows
                Dim role As New MBRole(r("Id"))
                roleArray.Add(role)
            Next r
            Return roleArray

        End Function


        Public Function Save() As Boolean
            Try
                If mId > 0 Then
                    Return Update()
                Else : Return Insert()
                End If
            Catch ex As Exception
                Throw ex
            End Try
        End Function
        Public Function Delete() As Boolean
            Try
                Dim strSQL As String
                Dim ds As DataSet
                Dim r As DataRow

                strSQL = "Delete FROM MBRole " & _
                    "WHERE Id=" & mId

                Return 0 < SqlHelper.ExecuteNonQuery(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            Catch ex As Exception
                Throw ex
            End Try
        End Function

        Public Function NameIsTaken(ByVal name As String) As Boolean

            Dim strSQL As String
        Dim ds As DataSet
        Dim r As DataRow

            strSQL = "SELECT name FROM MBRole " & _
                "WHERE name='" & Name & "'"

            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return False
            Else
                Return True
            End If
        End Function
        Public Function GetRoleIdByName(ByVal name As String) As Integer

            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            strSQL = "SELECT Id FROM MBRole " & _
                "WHERE name='" & name & "'"

            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return 0
            Else
                Return ds.Tables(0).Rows(0).Item("Id")
            End If
        End Function

#End Region

#Region "Private Methods"

        Private Function Update() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_UpdateMBRole", _
            mId, _
            mName, _
            mDesc)

            Return True
        End Function
        Private Function Insert() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_AddMBRole", _
            mName, _
            mDesc)
            If result > 0 Then
                mId = result
                Return True
            Else
                Return False
            End If
        End Function

#End Region


    End Class
End Namespace
