
'******************************************************************************
' FileName: MBSample.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports MobileBiologist.DataAccessObjects
Namespace MobileBiologist.BusinessObjects


    Public Class Sample
        Private mid As Integer
        Private mWaterSourceId As Integer
        Private mSampleDate As String
        Private mTemperature As Decimal
        Private mpH As Decimal
        Private mAmmonia As Decimal
        Private mNitrate As Decimal
        Private mnitrite As Decimal
        Private mNotes As String
        Private mImageNotes As Byte()
        Private mWaterSourceName As String


#Region "Properties"
        Public Property Id() As Integer
            Get
                Return mid
            End Get
            Set(ByVal Value As Integer)
                mid = Value
            End Set
        End Property
        Public Property WaterSourceId() As Integer
            Get
                Return mWaterSourceId
            End Get
            Set(ByVal Value As Integer)
                mWaterSourceId = Value
            End Set
        End Property
        Public Property SampleDate() As String
            Get
                Return mSampleDate
            End Get
            Set(ByVal Value As String)
                mSampleDate = Value
            End Set
        End Property
        Public Property Temperature() As Decimal
            Get
                Return mTemperature
            End Get
            Set(ByVal Value As Decimal)
                mTemperature = Value
            End Set
        End Property

        Public Property pH() As Decimal
            Get
                Return mpH
            End Get
            Set(ByVal Value As Decimal)
                mpH = Value
            End Set
        End Property
        Public Property Ammonia() As Decimal
            Get
                Return mAmmonia
            End Get
            Set(ByVal Value As Decimal)
                mAmmonia = Value
            End Set
        End Property
        Public Property Nitrate() As Decimal
            Get
                Return mNitrate
            End Get
            Set(ByVal Value As Decimal)
                mNitrate = Value
            End Set
        End Property
        Public Property Nitrite() As Decimal
            Get
                Return mnitrite
            End Get
            Set(ByVal Value As Decimal)
                mnitrite = Value
            End Set
        End Property
        Public Property Notes() As String
            Get
                Return mNotes
            End Get
            Set(ByVal Value As String)
                mNotes = Value
            End Set
        End Property
        Public Property ImageNotes() As Byte()
            Get
                Return mImageNotes
            End Get
            Set(ByVal Value As Byte())
                mImageNotes = Value
            End Set
        End Property
        Public ReadOnly Property WaterSourceName() As String
            Get
                Return mWaterSourceName
            End Get
        End Property
#End Region
#Region "Constructors"
        Public Sub New()

        End Sub
        Public Sub New(ByVal visitId As Integer)
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow


            mid = visitId

            strSQL = "SELECT * FROM Sample WHERE Id=" & mid
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then Return

            r = ds.Tables(0).Rows(0)

            If Not r("WaterSourceId") Is DBNull.Value Then
                mWaterSourceId = r("WaterSourceId")
            End If
            If Not r("SampleDate") Is DBNull.Value Then
                mSampleDate = r("SampleDate")
            End If
            If Not r("Temperature") Is DBNull.Value Then
                mTemperature = r("Temperature")
            End If
            If Not r("pH") Is DBNull.Value Then
                mpH = r("pH")
            End If
            If Not r("Ammonia") Is DBNull.Value Then
                mAmmonia = r("Ammonia")
            End If
            If Not r("Nitrate") Is DBNull.Value Then
                mNitrate = r("Nitrate")
            End If
            If Not r("Nitrite") Is DBNull.Value Then
                mnitrite = r("Nitrite")
            End If
            If Not r("Notes") Is DBNull.Value Then
                mNotes = r("Notes")
            End If
            If Not r("ImageNotes") Is DBNull.Value Then
                mImageNotes = r("ImageNotes")
            End If

            strSQL = "SELECT Name FROM WaterSource WHERE Id=" & mWaterSourceId
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count > 0 Then
                r = ds.Tables(0).Rows(0)
                mWaterSourceName = r("Name")
            End If


        End Sub
#End Region
#Region "Public Methods"
        Public Function GetSampleListByLocation(ByVal waterSourceId As Integer) As ArrayList
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            Dim sampleArray As New ArrayList

            strSQL = "SELECT * FROM Sample where WaterSourceId=" & waterSourceId
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return sampleArray
            End If

            For Each r In ds.Tables(0).Rows
                Dim s As New Sample(r("Id"))
                sampleArray.Add(s)
            Next r
            Return sampleArray

        End Function

        Public Function GetSampleReport(ByVal txtField As String, ByVal txtCompare As String, ByVal txtValue As String) As ArrayList
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            Dim sampleArray As New ArrayList

            strSQL = "SELECT * FROM Sample where " & txtField & " " & txtCompare & " " & txtValue
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return sampleArray
            End If

            For Each r In ds.Tables(0).Rows
                Dim s As New Sample(r("Id"))
                sampleArray.Add(s)
            Next r
            Return sampleArray

        End Function

        Public Function Save() As Boolean
            Try
                If mid > 0 Then
                    Return Update()
                Else : Return Insert()
                End If
            Catch ex As Exception
                Throw ex
            End Try
        End Function

        Public Function Delete() As Boolean
            Try
                Dim strSQL As String
                Dim ds As DataSet
                Dim r As DataRow

                strSQL = "Delete FROM Sample " & _
                    "WHERE Id=" & mid

                Return 0 < SqlHelper.ExecuteNonQuery(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            Catch ex As Exception
                Throw ex
            End Try

        End Function


#End Region
#Region "Private Methods"
        Private Function Update() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_UpdateSample", _
            mid, _
            mWaterSourceId, _
            mSampleDate, _
            mTemperature, _
            mpH, _
            mAmmonia, _
            mNitrate, _
            mnitrite, _
            mNotes, _
            mImageNotes)

            Return True
        End Function
        Private Function Insert() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_AddSample", _
            mWaterSourceId, _
            mSampleDate, _
            mTemperature, _
            mpH, _
            mAmmonia, _
            mNitrate, _
            mnitrite, _
            mNotes, _
            mImageNotes)
            If result > 0 Then
                mid = result
                Return True
            Else : Return False
            End If
        End Function

#End Region
    End Class
End Namespace
