
'******************************************************************************
' FileName: MBWaterSource.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports MobileBiologist.DataAccessObjects
Imports System.Drawing
Namespace MobileBiologist.BusinessObjects


    Public Class WaterSource


        Private mId As Integer
        Private mName As String
        Private mLocation As String
        Private mLatitude As String
        Private mLongitude As String
        Private mImageName As String
        Private mImageFile() As Byte
        Private mSamples As ArrayList


#Region "Properties"
        Public Property Id() As Integer
            Get
                Return mId
            End Get
            Set(ByVal Value As Integer)
                mId = Value
            End Set
        End Property
        Public Property Name() As String
            Get
                Return mName
            End Get
            Set(ByVal Value As String)
                mName = Value
            End Set
        End Property
        Public Property Location() As String
            Get
                Return mLocation
            End Get
            Set(ByVal Value As String)
                mLocation = Value
            End Set
        End Property
        Public Property Latitude() As String
            Get
                Return mLatitude
            End Get
            Set(ByVal Value As String)
                mLatitude = Value
            End Set
        End Property
        Public Property Longitude() As String
            Get
                Return mLongitude
            End Get
            Set(ByVal Value As String)
                mLongitude = Value
            End Set
        End Property
        Public Property ImageName() As String
            Get
                Return mImageName
            End Get
            Set(ByVal Value As String)
                mImageName = Value
            End Set
        End Property
        Public Property ImageFile() As Byte()
            Get
                Return mImageFile
            End Get
            Set(ByVal Value As Byte())
                mImageFile = Value
            End Set
        End Property


        Public Property Samples() As ArrayList
            Get
                Return mSamples
            End Get
            Set(ByVal Value As ArrayList)
                mSamples = Value
            End Set
        End Property

#End Region

#Region "Constructors"
        Public Sub New()

        End Sub

        Public Sub New(ByVal id As Integer)
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow


            mId = id

            strSQL = "SELECT * FROM WaterSource WHERE Id=" & mId
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then Return

            r = ds.Tables(0).Rows(0)

            If Not r("Name") Is DBNull.Value Then
                mName = r("Name")
            End If
            If Not r("Location") Is DBNull.Value Then
                mLocation = r("Location")
            End If
            If Not r("Latitude") Is DBNull.Value Then
                mLatitude = r("Latitude")
            End If
            If Not r("Longitude") Is DBNull.Value Then
                mLongitude = r("Longitude")
            End If
            If Not r("ImageName") Is DBNull.Value Then
                mImageName = r("ImageName")
            End If
            If Not r("ImageFile") Is DBNull.Value Then
                mImageFile = r("ImageFile")
            End If


            Dim s As New Sample
            mSamples = s.GetSampleListByLocation(mId)
        End Sub
#End Region

#Region "Public Methods"
        Public Function GetWaterSourceList() As ArrayList
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            Dim wsArray As New ArrayList


            strSQL = "SELECT * FROM WaterSource"
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return wsArray
            End If

            For Each r In ds.Tables(0).Rows
                Dim ws As New WaterSource(r("Id"))
                wsArray.Add(ws)
            Next r
            Return wsArray

        End Function


        Public Function Save() As Boolean
            Try
                If mId > 0 Then
                    Return Update()
                Else : Return Insert()
                End If
            Catch ex As Exception
                Throw ex
            End Try
        End Function

        Public Function Delete() As Boolean
            Try
                Dim strSQL As String
                Dim ds As DataSet
                Dim r As DataRow

                strSQL = "Delete FROM WaterSource " & _
                    "WHERE Id=" & mId

                Return 0 < SqlHelper.ExecuteNonQuery(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            Catch ex As Exception
                Throw ex
            End Try
        End Function
#End Region

#Region "Private Methods"

        Private Function Update() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_UpdateWaterSource", _
            mId, _
            mName, _
            mLocation, _
            mLatitude, _
            mLongitude, _
            mImageName, _
            mImageFile)

            Return True

        End Function
        Private Function Insert() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_AddWaterSource", _
            mName, _
            mLocation, _
            mLatitude, _
            mLongitude, _
            mImageName, _
            mImageFile)
            If result > 0 Then
                mId = result
                Return True
            Else : Return False
            End If
        End Function

#End Region

    End Class

End Namespace
