
'******************************************************************************
' FileName: MB_WS.asmx
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.Web.Services.Description
Imports System.Xml
Imports System.Xml.Schema
Imports System.Xml.Serialization
Imports System.Data
Imports System.Web.Security

Imports System.IO

Imports MobileBiologist.BusinessObjects
Namespace MobileBiologist.WebServices


    <System.Web.Services.WebService(Namespace:="http://tempuri.org/MobileBiolgist/WebServices/MB_WS")> _
    Public Class MB_WS
        Inherits System.Web.Services.WebService

#Region " Web Services Designer Generated Code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Web Services Designer.
            InitializeComponent()

            'Add your own initialization code after the InitializeComponent() call

        End Sub

        'Required by the Web Services Designer
        Private components As System.ComponentModel.IContainer

        'NOTE: The following procedure is required by the Web Services Designer
        'It can be modified using the Web Services Designer.  
        'Do not modify it using the code editor.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            components = New System.ComponentModel.Container
        End Sub

        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            'CODEGEN: This procedure is required by the Web Services Designer
            'Do not modify it using the code editor.
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

#End Region

        <WebMethod()> Public Function EchoString( _
        <XmlElement(DataType:="string")> ByVal strval As String) _
        As <XmlElement("MyTime", DataType:="time")> DateTime
            Return DateTime.Now
        End Function


        <WebMethod()> _
        Public Function GetWaterSources() As String

            Dim ws As New WaterSource
            Dim wsArray As ArrayList
            wsArray = ws.GetWaterSourceList

            Dim fileName As String

            Dim objXMLDoc As XmlDocument
            Dim objWSNode As XmlNode
            Dim objSampleNode As XmlNode
            Dim objNewNode As XmlNode
            Dim objRootDocNode As XmlNode
            Dim listNodes As XmlNodeList
            Dim intCounter As Integer
            Dim objXMLAttribute As XmlAttribute

            objXMLDoc = New XmlDocument
            fileName = Server.MapPath("/MB_WebServices/watersources.xml")

            objXMLDoc.Load(fileName)

            objRootDocNode = objXMLDoc.DocumentElement
            For Each ws In wsArray
                objWSNode = objXMLDoc.CreateElement("WaterSource")
                objXMLAttribute = objXMLDoc.CreateAttribute("Id")
                objXMLAttribute.Value = ws.Id
                objWSNode.Attributes.Append(objXMLAttribute)
                objWSNode = objRootDocNode.AppendChild(objWSNode)

                AddElement(objXMLDoc, objWSNode, objNewNode, "Name", ws.Name)
                AddElement(objXMLDoc, objWSNode, objNewNode, "Location", ws.Location)
                AddElement(objXMLDoc, objWSNode, objNewNode, "Latitude", ws.Latitude)
                AddElement(objXMLDoc, objWSNode, objNewNode, "Longitude", ws.Longitude)
                AddElement(objXMLDoc, objWSNode, objNewNode, "ImageName", ws.ImageName)

                'add the samples
                Dim al As ArrayList
                Dim s As Sample
                al = ws.Samples
                For Each s In al
                    objSampleNode = objXMLDoc.CreateElement("Sample")
                    objXMLAttribute = objXMLDoc.CreateAttribute("Id")
                    objXMLAttribute.Value = s.Id
                    objSampleNode.Attributes.Append(objXMLAttribute)
                    objSampleNode = objWSNode.AppendChild(objSampleNode)

                    AddElement(objXMLDoc, objSampleNode, objNewNode, "WaterSourceId", s.WaterSourceId)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "SampleDate", s.SampleDate)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "Temperature", s.Temperature)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "pH", s.pH)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "Ammonia", s.Ammonia)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "Nitrate", s.Nitrate)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "Nitrite", s.Nitrite)
                    AddElement(objXMLDoc, objSampleNode, objNewNode, "Notes", s.Notes)
                Next


            Next

            Dim strXML As String
            strXML = objXMLDoc.InnerXml
            Return strXML
        End Function

        <WebMethod()> _
        Public Function GetImageFile(ByVal waterSourceId As Integer) As Byte()
            Dim objWS As New WaterSource(waterSourceId)
            Return objWS.ImageFile
        End Function

        <WebMethod()> _
        Public Function GetImageNotes(ByVal sampleId As Integer) As Byte()
            Dim objS As New Sample(sampleId)
            Return objS.ImageNotes
        End Function

        <WebMethod()> _
        Public Function UpdateImageNotes(ByVal sampleId As Integer, ByVal imageNotes As Byte()) As Boolean
            Dim objS As New Sample(sampleId)
            objS.ImageNotes = imageNotes
            Return objS.Save()
        End Function

        <WebMethod()> _
        Public Function Login(ByVal username As String, ByVal password As String) As Boolean
            Dim u As New MBUser
            Return u.Login(username, password)
        End Function


        <WebMethod()> _
        Public Function AddSample(ByVal sampleXML As String) As Integer
            Dim s As Sample
            Dim objDom As XmlDocument
            Dim objSampleList As XmlNodeList
            Dim objSampleNode As XmlNode
            Dim objNode As XmlNode

            objDom = New XmlDocument
            objDom.LoadXml(sampleXML)

            objSampleList = objDom.DocumentElement.SelectNodes("Sample")
            For Each objSampleNode In objSampleList
                s = New Sample
                s.Id = 0
                s.WaterSourceId = objSampleNode.SelectSingleNode("WaterSourceId").InnerText
                s.SampleDate = objSampleNode.SelectSingleNode("SampleDate").InnerText
                s.Temperature = objSampleNode.SelectSingleNode("Temperature").InnerText
                s.pH = objSampleNode.SelectSingleNode("pH").InnerText
                s.Ammonia = objSampleNode.SelectSingleNode("Ammonia").InnerText
                s.Nitrate = objSampleNode.SelectSingleNode("Nitrate").InnerText
                s.Nitrite = objSampleNode.SelectSingleNode("Nitrite").InnerText
                s.Notes = objSampleNode.SelectSingleNode("Notes").InnerText
                s.Save()
            Next
            Return s.Id
        End Function

        <WebMethod()> _
        Public Function AddAllSamples(ByVal sampleXML As String) As Boolean
            Dim s As Sample
            Dim objDom As XmlDocument
            Dim objSampleList As XmlNodeList
            Dim objSampleNode As XmlNode
            Dim objNode As XmlNode

            objDom = New XmlDocument
            objDom.LoadXml(sampleXML)

            objSampleList = objDom.DocumentElement.SelectNodes("Sample")
            For Each objSampleNode In objSampleList
                s = New Sample
                s.Id = 0
                s.WaterSourceId = objSampleNode.SelectSingleNode("WaterSourceId").InnerText
                s.SampleDate = objSampleNode.SelectSingleNode("SampleDate").InnerText
                s.Temperature = objSampleNode.SelectSingleNode("Temperature").InnerText
                s.pH = objSampleNode.SelectSingleNode("pH").InnerText
                s.Ammonia = objSampleNode.SelectSingleNode("Ammonia").InnerText
                s.Nitrate = objSampleNode.SelectSingleNode("Nitrate").InnerText
                s.Nitrite = objSampleNode.SelectSingleNode("Nitrite").InnerText
                s.Notes = objSampleNode.SelectSingleNode("Notes").InnerText
                s.Save()
            Next
            Return True

        End Function


        Private Function AddElement(ByRef objXMLDoc As XmlDocument, _
            ByRef objParentNode As XmlNode, _
            ByRef objNewNode As XmlNode, _
            ByVal strName As String, _
            ByVal strValue As String)

            objNewNode = objXMLDoc.CreateElement(strName)
            objNewNode = objParentNode.AppendChild(objNewNode)
            objNewNode.AppendChild(objXMLDoc.CreateTextNode(strValue))

        End Function
    End Class
End Namespace
