
'******************************************************************************
' FileName: Global.asax
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports System.Web
Imports System.Web.SessionState
Imports System.Web.Security
Imports MobileBiologist.BusinessObjects

Namespace MobileBiologist.WebPages

    Public Class Global
        Inherits System.Web.HttpApplication

#Region " Component Designer Generated Code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Component Designer.
            InitializeComponent()

            'Add any initialization after the InitializeComponent() call

        End Sub

        'Required by the Component Designer
        Private components As System.ComponentModel.IContainer

        'NOTE: The following procedure is required by the Component Designer
        'It can be modified using the Component Designer.
        'Do not modify it using the code editor.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            components = New System.ComponentModel.Container
        End Sub

#End Region

        Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
            ' Fires when the application is started
        End Sub

        Sub Session_Start(ByVal sender As Object, ByVal e As EventArgs)
            ' Fires when the session is started
        End Sub

        Sub Application_BeginRequest(ByVal sender As Object, ByVal e As EventArgs)
            ' Fires at the beginning of each request
        End Sub

        Public cookieName As String = "userinfo"

        Sub Application_AuthenticateRequest(ByVal sender As Object, ByVal e As EventArgs)
            ' Fires upon attempting to authenticate the user
            Dim userInformation As String = [String].Empty

            If Request.IsAuthenticated = True Then
                If Not TypeOf Context.User Is CustomPrincipal Then
                    ' Create the roles cookie if it doesn't exist yet for this session.
                    If (Request.Cookies(cookieName) Is Nothing Or Request.Cookies(cookieName) Is "") Then
                        ' Retrieve the user's role and ID information and add it to
                        ' the cookie
                        Dim usr As New MBUser(User.Identity.Name)

                        ' Create a string to persist the role and user id
                        userInformation = usr.Id & ";" & usr.RoleName & ";" & usr.Name & ";" & usr.Username

                        ' Create a cookie authentication ticket.
                        Dim ticket As New FormsAuthenticationTicket(1, User.Identity.Name, DateTime.Now, DateTime.Now.AddHours(1), False, userInformation)
                        ' version
                        ' user name
                        ' issue time
                        ' expires every hour
                        ' don't persist cookie

                        ' Encrypt the ticket
                        Dim cookieStr As [String] = FormsAuthentication.Encrypt(ticket)

                        ' Send the cookie to the client
                        Response.Cookies(cookieName).Value = cookieStr
                        Response.Cookies(cookieName).Path = "/"
                        Response.Cookies(cookieName).Expires = DateTime.Now.AddHours(1)
                        ' Add our own custom principal to the request containing the user's identity, the user id, and
                        ' the user's role 

                        Context.User = New CustomPrincipal(User.Identity, usr.Id, usr.RoleName, usr.Name, usr.Username)
                    Else
                        ' Get roles from roles cookie
                        Dim ticket As FormsAuthenticationTicket = FormsAuthentication.Decrypt(Context.Request.Cookies(cookieName).Value)
                        userInformation = ticket.UserData

                        ' Add our own custom principal to the request containing the user's identity, the user id, and
                        ' the user's role from the auth ticket
                        Dim info As String() = userInformation.Split(New Char() {";"c})
                        Context.User = New CustomPrincipal(User.Identity, Convert.ToInt32(info(0).ToString()), info(1).ToString(), info(2).ToString(), info(3).ToString())
                    End If
                End If
            End If

        End Sub

        Sub Application_Error(ByVal sender As Object, ByVal e As EventArgs)
            ' Fires when an error occurs
        End Sub

        Sub Session_End(ByVal sender As Object, ByVal e As EventArgs)
            ' Fires when the session ends
        End Sub

        Sub Application_End(ByVal sender As Object, ByVal e As EventArgs)
            ' Fires when the application ends
        End Sub

    End Class
End Namespace
