
'******************************************************************************
' FileName: login.aspx
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports System.Web.Security
Imports MobileBiologist.BusinessObjects
Namespace MobileBiologist.WebPages
    Public Class login
        Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub
        Protected WithEvents Image1 As System.Web.UI.WebControls.Image
        Protected WithEvents lblUsername As System.Web.UI.WebControls.Label
        Protected WithEvents txtUsername As System.Web.UI.WebControls.TextBox
        Protected WithEvents Label2 As System.Web.UI.WebControls.Label
        Protected WithEvents txtPassword As System.Web.UI.WebControls.TextBox
        Protected WithEvents chkSaveLogin As System.Web.UI.WebControls.CheckBox
        Protected WithEvents cmdLogin As System.Web.UI.WebControls.Button
        Protected WithEvents pnlLogin As System.Web.UI.WebControls.Panel
        Protected WithEvents txtReturnURL As System.Web.UI.WebControls.TextBox
        Protected WithEvents lblMessage As System.Web.UI.WebControls.Label
        Protected WithEvents pnlRegister As System.Web.UI.WebControls.Panel
        Protected WithEvents cmdRegister As System.Web.UI.WebControls.Button
        Protected WithEvents Label1 As System.Web.UI.WebControls.Label
        Protected WithEvents Label3 As System.Web.UI.WebControls.Label
        Protected WithEvents Label4 As System.Web.UI.WebControls.Label
        Protected WithEvents Label5 As System.Web.UI.WebControls.Label
        Protected WithEvents txtFirst_add As System.Web.UI.WebControls.TextBox
        Protected WithEvents Label6 As System.Web.UI.WebControls.Label
        Protected WithEvents Label7 As System.Web.UI.WebControls.Label
        Protected WithEvents txtLast_add As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtEmail_add As System.Web.UI.WebControls.TextBox
        Protected WithEvents HyperLink1 As System.Web.UI.WebControls.HyperLink
        Protected WithEvents txtUsername_add As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtPassword_add As System.Web.UI.WebControls.TextBox
        Protected WithEvents TextBox1 As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtConfirmPassword_add As System.Web.UI.WebControls.TextBox
        Protected WithEvents lblLogin As System.Web.UI.WebControls.Label

        'NOTE: The following placeholder declaration is required by the Web Form Designer.
        'Do not delete or move it.
        Private designerPlaceholderDeclaration As System.Object

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            If Not IsPostBack Then
                If Request.QueryString("ReturnURL") <> "" Then
                    txtReturnURL.Text = Request.QueryString("ReturnURL")
                End If
                If Request.QueryString("method") = "logout" Then
                    'log the user out
                    FormsAuthentication.SignOut()
                    If Not Request.Cookies("userinfo") Is Nothing Then
                        Request.Cookies("userinfo").Value = ""
                    End If
                    context.User = Nothing
                ElseIf Request.QueryString("method") = "register" Then
                    pnlRegister.Visible = True
                    pnlLogin.Visible = False
                    lblLogin.Text = "Register"
                End If
                If Request.QueryString("message") <> "" Then
                    lblMessage.Text = Request.QueryString("message")
                End If

            End If
        End Sub

        Private Sub cmdLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdLogin.Click
            Try
                Dim user As New MBUser
                Dim uid As Integer

                Dim userinformation As String

                Dim g As New Global
                Dim cookieName As String = g.cookieName

                uid = user.Login(txtUsername.Text, txtPassword.Text)

                If uid > 0 Then
                    ' Use security system to set the UserID witin a client-side Cookie
                    FormsAuthentication.SetAuthCookie(txtUsername.Text, chkSaveLogin.Checked)

                    ' Retrieve the user's role and ID information and add it to
                    ' the cookie
                    user = New MBUser(uid)

                    ' Create a string to persist the role and user id
                    userinformation = user.Id & ";" & user.RoleName & ";" & user.Name & ";" & user.Username

                    ' Create a cookie authentication ticket.
                    ' version
                    ' user id
                    ' issue time
                    ' expires every hour
                    ' don't persist cookie
                    Dim ticket As New FormsAuthenticationTicket(1, user.Id, DateTime.Now, DateTime.Now.AddHours(1), chkSaveLogin.Checked, userinformation)

                    ' Encrypt the ticket
                    Dim cookieStr As [String] = FormsAuthentication.Encrypt(ticket)

                    ' Send the cookie to the client
                    Response.Cookies(cookieName).Value = cookieStr
                    Response.Cookies(cookieName).Path = "/"
                    Response.Cookies(cookieName).Path = "/"
                    If chkSaveLogin.Checked = True Then
                        Response.Cookies(cookieName).Expires = DateTime.Now.AddYears(10)
                    Else
                        Response.Cookies(cookieName).Expires = DateTime.Now.AddHours(1)
                    End If

                    ' Redirect browser back to originating page
                    If txtReturnURL.Text <> "" Then
                        Response.Redirect(txtReturnURL.Text)
                    Else
                        Response.Redirect(Request.ApplicationPath)
                    End If
                Else
                    lblMessage.Text = "Invalid user id and password"
                End If
            Catch ex As Exception
                lblMessage.Text = "Invalid user id and password"
            End Try


        End Sub

        Private Sub cmdRegister_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRegister.Click

            Dim user As New MBUser
            Dim r As New MBRole

            Try
                If user.NameIsTaken(txtUsername_add.Text) Then
                    lblMessage.Text = "ERROR: That name is already taken"
                Else

                    user.Username = txtUsername_add.Text
                    user.FirstName = txtFirst_add.Text
                    user.LastName = txtLast_add.Text
                    user.Email = txtEmail_add.Text
                    user.RoleId = r.GetRoleIdByName("DEFAULT")
                    user.RoleName = "DEFAULT"
                    user.Password = txtPassword_add.Text

                    user.Save()

                    lblMessage.Text = "You were successfully registered in the DEFAULT role. Please talk to an administrator to upgrade your role assignment. Enter your id and password to login."
                    pnlRegister.Visible = False
                    pnlLogin.Visible = True
                    lblLogin.Text = "Login"
                End If
            Catch ex As Exception
                Response.Redirect("login.aspx?message=" & ex.Message)
            End Try


        End Sub
    End Class

End Namespace
