
'******************************************************************************
' FileName: Gallery.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports MobileMuseum.DataAccessObjects

Namespace MobileMuseum.BusinessObjects

    Public Class Gallery
        Private mId As Integer
        Private mNumber As String
        Private mName As String
        Private mMainImage As String
        Private mSmallImage As String
        Private mPaintings As ArrayList

#Region "Properties"
        Public Property Id() As Integer
            Get
                Return mId
            End Get
            Set(ByVal Value As Integer)
                mId = Value
            End Set
        End Property
        Public Property Number() As String
            Get
                Return mNumber
            End Get
            Set(ByVal Value As String)
                mNumber = Value
            End Set
        End Property
        Public Property Name() As String
            Get
                Return mName
            End Get
            Set(ByVal Value As String)
                mName = Value
            End Set
        End Property
        Public Property MainImage() As String
            Get
                Return mMainImage
            End Get
            Set(ByVal Value As String)
                mMainImage = Value
            End Set
        End Property
        Public Property SmallImage() As String
            Get
                Return mSmallImage
            End Get
            Set(ByVal Value As String)
                mSmallImage = Value
            End Set
        End Property
        Public Property Paintings() As ArrayList
            Get
                Return mPaintings
            End Get
            Set(ByVal Value As ArrayList)
                mPaintings = Value
            End Set
        End Property
#End Region

#Region "Constructors"
        Public Sub New()

        End Sub
        Public Sub New(ByVal galleryId As Integer)
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            mId = galleryId

            strSQL = "SELECT * FROM Gallery WHERE Id=" & mId & " ORDER BY Number"
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then Return

            r = ds.Tables(0).Rows(0)

            If Not r("Number") Is DBNull.Value Then
                mNumber = r("Number")
            End If
            If Not r("Name") Is DBNull.Value Then
                mName = r("Name")
            End If
            If Not r("MainImage") Is DBNull.Value Then
                mMainImage = r("MainImage")
            End If
            If Not r("SmallImage") Is DBNull.Value Then
                mSmallImage = r("SmallImage")
            End If

            Dim objPainting As New Painting
            mPaintings = objPainting.GetPaintingsByGallery(mId)

        End Sub

#End Region

#Region "Public Methods"
        Public Function GetGalleryList() As ArrayList
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            Dim galleryArray As New ArrayList

            strSQL = "SELECT Id FROM Gallery ORDER BY Number"
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return galleryArray
            End If

            For Each r In ds.Tables(0).Rows
                Dim s As New Gallery(r("Id"))
                galleryArray.Add(s)
            Next r
            Return galleryArray

        End Function

        Public Function Save() As Boolean
            Try
                If mId > 0 Then
                    Return Update()
                Else : Return Insert()
                End If
            Catch ex As Exception
                Throw ex
            End Try
        End Function

        Public Function Delete() As Boolean
            Try
                Dim strSQL As String
                Dim ds As DataSet
                Dim r As DataRow

                strSQL = "Delete FROM Gallery " & _
                    "WHERE Id=" & mId

                Return 0 < SqlHelper.ExecuteNonQuery(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            Catch ex As Exception
                Throw ex
            End Try

        End Function


#End Region

#Region "Private Methods"
        Private Function Update() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_UpdateGallery", _
            mId, _
            mNumber, _
            mName, _
            mMainImage, _
            mSmallImage)

            Return True
        End Function
        Private Function Insert() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_AddGallery", _
            mNumber, _
            mName, _
            mMainImage, _
            mSmallImage)
            If result > 0 Then
                mId = result
                Return True
            Else : Return False
            End If
        End Function

#End Region


    End Class
End Namespace
