
'******************************************************************************
' FileName: MMUser.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports MobileMuseum.DataAccessObjects
Namespace MobileMuseum.BusinessObjects

    Public Class MMUser
        Private mid As Integer
        Private mUsername As String
        Private mFirstName As String
        Private mLastName As String
        Private mEmail As String
        Private mPassword As String
        Private mRoleId As Integer
        Private mRoleName As String

#Region "Properties"
        Public Property Id() As Integer
            Get
                Return mid
            End Get
            Set(ByVal Value As Integer)
                mid = Value
            End Set
        End Property
        Public Property Username() As String
            Get
                Return mUsername
            End Get
            Set(ByVal Value As String)
                mUsername = Value
            End Set
        End Property
        Public Property FirstName() As String
            Get
                Return mFirstName
            End Get
            Set(ByVal Value As String)
                mFirstName = Value
            End Set
        End Property
        Public Property LastName() As String
            Get
                Return mLastName
            End Get
            Set(ByVal Value As String)
                mLastName = Value
            End Set
        End Property
        Public Property Email() As String
            Get
                Return mEmail
            End Get
            Set(ByVal Value As String)
                mEmail = Value
            End Set
        End Property
        Public Property Password() As String
            Get
                Return mPassword
            End Get
            Set(ByVal Value As String)
                mPassword = Value
            End Set
        End Property
        Public Property RoleId() As Integer
            Get
                Return mRoleId
            End Get
            Set(ByVal Value As Integer)
                mRoleId = Value
            End Set
        End Property
        Public Property RoleName() As String
            Get
                Return mRoleName
            End Get
            Set(ByVal Value As String)
                mRoleName = Value
            End Set
        End Property
        Public ReadOnly Property Name() As String
            Get
                Return mFirstName & " " & mLastName
            End Get
        End Property
#End Region

#Region "Constructors"
        Public Sub New()

        End Sub
        Public Sub New(ByVal id As Integer)
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow


            mid = id

            strSQL = "SELECT MMUser.*, MMRole.Id as MMRoleId, MMRole.Name as MMRoleName FROM MMUser LEFT OUTER JOIN MMROLE ON MMUser.RoleId=MMRole.Id WHERE MMUser.Id=" & mid
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then Return

            r = ds.Tables(0).Rows(0)

            If Not r("Username") Is DBNull.Value Then
                mUsername = r("Username")
            End If
            If Not r("FirstName") Is DBNull.Value Then
                mFirstName = r("FirstName")
            End If
            If Not r("LastName") Is DBNull.Value Then
                mLastName = r("LastName")
            End If
            If Not r("Email") Is DBNull.Value Then
                mEmail = r("Email")
            End If
            If Not r("Password") Is DBNull.Value Then
                mPassword = r("Password")
            End If
            If Not r("MMRoleId") Is DBNull.Value Then
                mRoleId = r("MMRoleId")
            End If
            If Not r("MMRoleName") Is DBNull.Value Then
                mRoleName = r("MMRoleName")
            End If

        End Sub
#End Region

#Region "Public Methods"
        Public Function GetUserList() As ArrayList
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            Dim userArray As New ArrayList

            strSQL = "SELECT * FROM MMUser"
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return userArray
            End If

            For Each r In ds.Tables(0).Rows
                Dim usr As New MMUser(r("Id"))
                userArray.Add(usr)
            Next r
            Return userArray

        End Function


        Public Function Save() As Boolean
            Try
                If mid > 0 Then
                    Return Update()
                Else : Return Insert()
                End If
            Catch ex As Exception
                Throw ex
            End Try
        End Function
        Public Function Delete() As Boolean
            Try
                Dim strSQL As String
                Dim ds As DataSet
                Dim r As DataRow

                strSQL = "Delete FROM MMUser " & _
                    "WHERE Id=" & mid

                Return 0 < SqlHelper.ExecuteNonQuery(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            Catch ex As Exception
                Throw ex
            End Try
        End Function

        Public Function Login(ByVal username As String, ByVal password As String) As Integer
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            Dim userArray As New ArrayList

            strSQL = "SELECT Id FROM MMUser " & _
                "WHERE Username='" & username & "'" & _
                "AND Password='" & password & "'"

            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return 0
            Else
                Return ds.Tables(0).Rows(0).Item("Id")
                Return True
            End If

        End Function

        Public Function NameIsTaken(ByVal username As String)
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            strSQL = "SELECT username FROM MMUser " & _
                "WHERE Username='" & username & "'"

            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return False
            Else
                Return True
            End If

        End Function
#End Region

#Region "Private Methods"

        Private Function Update() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_UpdateMMUser", _
            mid, _
            mUsername, _
            mFirstName, _
            mLastName, _
            mEmail, _
            mPassword, _
            mRoleId)

            Return True
        End Function
        Private Function Insert() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_AddMMUser", _
            mUsername, _
            mFirstName, _
            mLastName, _
            mEmail, _
            mPassword, _
            mRoleId)
            If result > 0 Then
                mid = result
                Return True
            Else
                Return False
            End If
        End Function

#End Region


    End Class
End Namespace
