
'******************************************************************************
' FileName: Painting.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports MobileMuseum.DataAccessObjects

Namespace MobileMuseum.BusinessObjects

    Public Class Painting
        Private mId As Integer
        Private mGalleryId As Integer
        Private mNumber As String
        Private mTitle As String
        Private mPainter As String
        Private mDates As String
        Private mDescription As String
        Private mMainImage As String
        Private mSmallImage As String

#Region "Properties"
        Public Property Id() As Integer
            Get
                Return mId
            End Get
            Set(ByVal Value As Integer)
                mId = Value
            End Set
        End Property
        Public Property GalleryId() As Integer
            Get
                Return mGalleryId
            End Get
            Set(ByVal Value As Integer)
                mGalleryId = Value
            End Set
        End Property
        Public Property Number() As String
            Get
                Return mNumber
            End Get
            Set(ByVal Value As String)
                mNumber = Value
            End Set
        End Property
        Public Property Title() As String
            Get
                Return mTitle
            End Get
            Set(ByVal Value As String)
                mTitle = Value
            End Set
        End Property
        Public Property Painter() As String
            Get
                Return mPainter
            End Get
            Set(ByVal Value As String)
                mPainter = Value
            End Set
        End Property
        Public Property Dates() As String
            Get
                Return mDates
            End Get
            Set(ByVal Value As String)
                mDates = Value
            End Set
        End Property
        Public Property Description() As String
            Get
                Return mDescription
            End Get
            Set(ByVal Value As String)
                mDescription = Value
            End Set
        End Property
        Public Property MainImage() As String
            Get
                Return mMainImage
            End Get
            Set(ByVal Value As String)
                mMainImage = Value
            End Set
        End Property
        Public Property SmallImage() As String
            Get
                Return mSmallImage
            End Get
            Set(ByVal Value As String)
                mSmallImage = Value
            End Set
        End Property
#End Region

#Region "Constructors"
        Public Sub New()

        End Sub
        Public Sub New(ByVal paintingId As Integer)
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            mId = paintingId

            strSQL = "SELECT * FROM Painting WHERE Id=" & mId
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then Return

            r = ds.Tables(0).Rows(0)

            If Not r("GalleryId") Is DBNull.Value Then
                mGalleryId = r("GalleryId")
            End If

            If Not r("Number") Is DBNull.Value Then
                mNumber = r("Number")
            End If
            If Not r("Title") Is DBNull.Value Then
                mTitle = r("Title")
            End If
            If Not r("Painter") Is DBNull.Value Then
                mPainter = r("Painter")
            End If
            If Not r("Dates") Is DBNull.Value Then
                mDates = r("Dates")
            End If
            If Not r("Description") Is DBNull.Value Then
                mDescription = r("Description")
            End If
            If Not r("MainImage") Is DBNull.Value Then
                mMainImage = r("MainImage")
            End If
            If Not r("SmallImage") Is DBNull.Value Then
                mSmallImage = r("SmallImage")
            End If

        End Sub

#End Region

#Region "Public Methods"
        Public Function GetPaintingsByGallery(ByVal galleryId As Integer) As ArrayList
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            Dim paintingArray As New ArrayList

            strSQL = "SELECT Id FROM Painting WHERE GalleryId=" & galleryId & " ORDER BY Number"
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return paintingArray
            End If

            For Each r In ds.Tables(0).Rows
                Dim s As New Painting(r("Id"))
                paintingArray.Add(s)
            Next r
            Return paintingArray

        End Function

        Public Function Save() As Boolean
            Try
                If mId > 0 Then
                    Return Update()
                Else : Return Insert()
                End If
            Catch ex As Exception
                Throw ex
            End Try
        End Function

        Public Function Delete() As Boolean
            Try
                Dim strSQL As String
                Dim ds As DataSet
                Dim r As DataRow

                strSQL = "Delete FROM Painting " & _
                    "WHERE Id=" & mId

                Return 0 < SqlHelper.ExecuteNonQuery(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            Catch ex As Exception
                Throw ex
            End Try

        End Function


#End Region

#Region "Private Methods"
        Private Function Update() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_UpdatePainting", _
            mId, _
            mGalleryId, _
            mNumber, _
            mTitle, _
            mPainter, _
            mDates, _
            mDescription, _
            mMainImage, _
            mSmallImage)

            Return True
        End Function
        Private Function Insert() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_AddPainting", _
            mGalleryId, _
            mNumber, _
            mTitle, _
            mPainter, _
            mDates, _
            mDescription, _
            mMainImage, _
            mSmallImage)
            If result > 0 Then
                mId = result
                Return True
            Else : Return False
            End If
        End Function

#End Region


    End Class
End Namespace
