
Imports System
Imports System.IO
Imports System.Data
Imports System.Data.Common
Imports System.Data.SqlServerCe
Imports System.Collections
Imports System.Xml


Namespace MobileZoo.PPC.Setup

    Public Class MZ_Util


        Public Sub New()

        End Sub

        Private Shared db As String = "\mz_db.sdf"

        Private Const strCreateProspectTable = _
        "CREATE TABLE Prospect(" & _
        "Id int, " & _
        "FirstName nvarchar (50), " & _
        "MiddleInitial nvarchar (50), " & _
        "LastName nvarchar (50), " & _
        "Address nvarchar (50), " & _
        "Apartment nvarchar (50), " & _
        "City nvarchar (50), " & _
        "State nvarchar (50), " & _
        "Zip nvarchar (50), " & _
        "Country nvarchar (50), " & _
        "DaytimePhone nvarchar (50), " & _
        "EmailAddress nvarchar (255), " & _
        "GiftAmount nvarchar (50), " & _
        "DataComplete bit, " & _
        "AccountNumber nvarchar (50), " & _
        "CreditCard nvarchar (50), " & _
        "ExpDateMonth int, " & _
        "ExpDateYear int, " & _
        "LastUpdateDate datetime)"


        Public Function GetDBName() As String
            Return db
        End Function
        Public Function GetStrConn() As String
            Return "Data Source=" & db & ";password=test" ';encrypt database=true" ';persist security info=false"
        End Function

        Public Function CheckInitialized() As Boolean
            Dim u As New MZ_Util
            If SqlCEHelper.DBExists(u.GetDBName) Then
                Return True
            Else
                Return False
            End If
        End Function

        Public Function CheckForChanges() As Boolean
            Dim ds As DataSet
            Dim u As MZ_Util = New MZ_Util
            Dim strsql As String

            'check for changes in Item table
            strsql = "SELECT Id FROM Item where Id < 0"
            ds = SqlCEHelper.ExecuteDataset _
            (u.GetStrConn, strsql)
            If ds.Tables(0).Rows.Count > 0 Then
                Return True
            End If

            Return False
        End Function

        Public Function InitializeDB() As Boolean
            Dim u As New MZ_Util
            If Not SqlCEHelper.DBExists(u.GetDBName) Then
                SqlCEHelper.CreateDB(u.GetStrConn)
            End If

            Try
                'create table prospect
                SqlCEHelper.ExecuteCommand _
                (u.GetStrConn, _
                strCreateProspectTable)

            Catch ex As SqlCeException
                SqlCEHelper.DeleteDB(Me.GetStrConn)
                Return False
            End Try

            Return True
        End Function

        Public Function CleanDatabase() As Boolean
            Dim strsql As String

            strsql = "DELETE FROM Prospect"
            SqlCEHelper.ExecuteCommand _
            (Me.GetStrConn, strsql)
        End Function




        Public Function GetTempId() As Integer
            Dim result As Integer
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow
            Dim u As New MZ_Util

            'get temp id
            strSQL = "SELECT MIN(Id) as TempId from Prospect"
            ds = SqlCEHelper.ExecuteDataset _
            (u.GetStrConn, strSQL)

            r = ds.Tables(0).Rows(0)
            If r("TempId") Is DBNull.Value Then
                result = -1
            Else
                result = r("TempId") - 1
                If result >= 0 Then result = -1
            End If
            Return result
        End Function
    End Class


End Namespace
