
Imports System
Imports System.IO
Imports System.Data
Imports System.Data.Common
Imports System.Data.SqlServerCe
Imports System.Collections
Imports System.Xml

Imports MobileZoo.PPC.DataAccessObjects

Namespace MobileZoo.PPC.BusinessObjects

    Public Class MZ_Util


        Public Sub New()

        End Sub
        Private Shared db As String = "\Program Files\pwhost\MobileZoo\mz_db.sdf"


        Public Function GetDBName() As String
            Return db
        End Function
        Public Function GetStrConn() As String
            Return "Data Source=" & db & ";password=test" ';encrypt database=true" ';persist security info=false"
        End Function
        Public Function GetURL() As String
            Dim objXMLDoc As New XmlDocument
            Dim fileName As String
            Dim objNode As XmlNode
            Dim objNodes As XmlNodeList
            Dim url As String

            fileName = "\Program Files\pwhost\MobileZoo\MZ_config.xml"
            objXMLDoc.Load(fileName)
            For Each objNode In objXMLDoc.DocumentElement.ChildNodes
                If objNode.Name = "URL" Then
                    url = objNode.InnerText
                End If
            Next
            'url = "http://192.168.1.102/MI_WebServices/MI_WS.asmx"
            Return url

        End Function


        Public Function CheckConnection() As Boolean
            Try
                Dim d As Date
                Dim proxy As New Server.MZ_WS
                Dim u As New MZ_Util

                proxy.Url = u.GetURL
                d = proxy.EchoString("test")
                Return True
            Catch ex As Exception
                Return False
            End Try
        End Function
        Public Function CheckInitialized() As Boolean
            Dim u As MZ_Util = New MZ_Util
            If SqlCEHelper.DBExists(u.GetDBName) Then
                Return True
            Else
                Return False
            End If
        End Function
        Public Function CheckForChanges() As Integer
            Dim ds As DataSet
            Dim u As MZ_Util = New MZ_Util
            Dim strsql As String

            'check for changes in Item table
            strsql = "SELECT Id FROM Prospect where Id < 0"
            ds = SqlCEHelper.ExecuteDataset _
            (u.GetStrConn, strsql)
            Return ds.Tables(0).Rows.Count
        End Function

        Public Function CleanDatabase() As Boolean
            Dim strsql As String

            strsql = "DELETE FROM Prospect"
            SqlCEHelper.ExecuteCommand _
            (Me.GetStrConn, strsql)

        End Function


        Public Function GetProspects() As DataSet
            Dim strsql As String
            Dim ds As DataSet

            strsql = "SELECT Id,Firstname, Lastname from Prospect"
            ds = SqlCEHelper.ExecuteDataset _
            (Me.GetStrConn, strsql)
            Return ds
        End Function


        Public Function AddProspect(ByVal firstname As String, _
                                ByVal lastname As String, _
                                ByVal middleinitial As String, _
                                ByVal address As String, _
                                ByVal apartment As String, _
                                ByVal city As String, _
                                ByVal state As String, _
                                ByVal zip As String, _
                                ByVal country As String, _
                                ByVal daytimephone As String, _
                                ByVal emailaddress As String, _
                                ByVal giftamount As String, _
                                ByVal creditcard As String, _
                                ByVal expdatemonth As String, _
                                ByVal expdateyear As String, _
                                ByVal accountnumber As String, _
                                ByVal datacomplete As String, _
                                ByVal lastupdatedate As DateTime) _
                                As Boolean
            Dim strsql As String
            Dim ds As DataSet
            Dim id As Integer = Me.GetTempId

            strsql = "INSERT INTO Prospect " & _
            "(Id, " & _
                "FirstName, " & _
                "LastName, " & _
                "MiddleInitial, " & _
                "Address, " & _
                "Apartment, " & _
                "City, " & _
                "State, " & _
                "Zip, " & _
                "Country, " & _
                "DaytimePhone, " & _
                "EmailAddress, " & _
                "GiftAmount, " & _
                "CreditCard, " & _
                "ExpDateMonth, " & _
                "ExpDateYear, " & _
                "AccountNumber, " & _
                "DataComplete, " & _
                "LastUpdateDate)" & _
            "VALUES(" & _
            "" & id & ", " & _
            "'" & firstname & "', " & _
            "'" & lastname & "', " & _
            "'" & middleinitial & "', " & _
            "'" & address & "', " & _
            "'" & apartment & "', " & _
            "'" & city & "', " & _
            "'" & state & "', " & _
            "'" & zip & "', " & _
            "'" & country & "', " & _
            "'" & daytimephone & "', " & _
            "'" & emailaddress & "', " & _
            "'" & giftamount & "', " & _
            "'" & creditcard & "', " & _
            "'" & expdatemonth & "', " & _
            "'" & expdateyear & "', " & _
            "'" & accountnumber & "', " & _
            "'" & datacomplete & "', " & _
            "'" & lastupdatedate & "')"


            SqlCEHelper.ExecuteCommand _
            (Me.GetStrConn, strsql)
            Return True
        End Function

        Public Function AddProspectsToServer() As Boolean
            Dim proxy As New Server.MZ_WS
            Dim u As New MZ_Util
            Dim strXML As String
            Dim objXMLDoc As XmlDocument
            Dim objProspectNode As XmlNode
            Dim objNewNode As XmlNode
            Dim objRootDocNode As XmlNode
            Dim reader As XmlNodeReader
            Dim objXMLAttribute As XmlAttribute

            Dim strsql As String
            Dim ds As DataSet
            Dim r As DataRow

            strsql = "SELECT * from Prospect Where Id < 0"
            ds = SqlCEHelper.ExecuteDataset _
            (Me.GetStrConn, strsql)

            Dim fileName As String
            objXMLDoc = New XmlDocument
            fileName = "\Program Files\pwhost\MobileZoo\Prospects.xml"
            objXMLDoc.Load(fileName)


            objRootDocNode = objXMLDoc.DocumentElement

            For Each r In ds.Tables(0).Rows
                objProspectNode = objXMLDoc.CreateElement("Prospect")
                objXMLAttribute = objXMLDoc.CreateAttribute("Id")
                objXMLAttribute.Value = r("Id")
                objProspectNode.Attributes.Append(objXMLAttribute)
                objProspectNode = objRootDocNode.AppendChild(objProspectNode)

                AddElement(objXMLDoc, objProspectNode, objNewNode, "AccountNumber", r("AccountNumber"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "Address", r("Address"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "Apartment", r("Apartment"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "City", r("City"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "Country", r("Country"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "CreditCard", r("CreditCard"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "DataComplete", r("DataComplete"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "DaytimePhone", r("DaytimePhone"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "EmailAddress", r("EmailAddress"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "ExpDateMonth", r("ExpDateMonth"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "ExpDateYear", r("ExpDateYear"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "FirstName", r("FirstName"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "GiftAmount", r("GiftAmount"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "LastName", r("LastName"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "LastUpdateDate", r("LastUpdateDate"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "MiddleInitial", r("MiddleInitial"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "State", r("State"))
                AddElement(objXMLDoc, objProspectNode, objNewNode, "Zip", r("Zip"))


            Next
            strXML = objXMLDoc.InnerXml


            proxy.Url = u.GetURL
            If proxy.AddProspects(strXML) Then
                u.CleanDatabase()
                Return True
            Else
                Return False
            End If
        End Function
        Public Function GetTempId() As Integer
            Dim result As Integer
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow
            Dim u As New MZ_Util

            'get temp id
            strSQL = "SELECT MIN(Id) as TempId from Prospect"
            ds = SqlCEHelper.ExecuteDataset _
            (u.GetStrConn, strSQL)

            r = ds.Tables(0).Rows(0)
            If r("TempId") Is DBNull.Value Then
                result = -1
            Else
                result = r("TempId") - 1
                If result >= 0 Then result = -1
            End If
            Return result
        End Function

        Private Function AddElement(ByRef objXMLDoc As XmlDocument, _
            ByRef objParentNode As XmlNode, _
            ByRef objNewNode As XmlNode, _
            ByVal strName As String, _
            ByVal strValue As String)

            objNewNode = objXMLDoc.CreateElement(strName)
            objNewNode = objParentNode.AppendChild(objNewNode)
            objNewNode.AppendChild(objXMLDoc.CreateTextNode(strValue))
        End Function


    End Class



End Namespace
