
'******************************************************************************
' FileName: Prospect.vb
' Author:   VL, HS, RS
' Created:  Nov-2003
'*****************************************************************************

Imports MobileZoo.DataAccessObjects
Namespace MobileZoo.BusinessObjects
    Public Class Prospect

        Private mId As Integer
        Private mFirstName As String
        Private mMiddleInitial As String
        Private mLastName As String
        Private mAddress As String
        Private mApartment As String
        Private mCity As String
        Private mState As String
        Private mZip As String
        Private mCountry As String
        Private mDaytimePhone As String
        Private mEmailAddress As String
        Private mGiftAmount As String
        Private mDataComplete As Boolean
        Private mAccountNumber As String
        Private mCreditCard As String
        Private mExpDateMonth As Integer
        Private mExpDateYear As Integer
        Private mLastUpdateDate As String

#Region "Properties"
        Public Property Id() As Integer
            Get
                Return mId
            End Get
            Set(ByVal Value As Integer)
                mId = Value
            End Set
        End Property
        Public Property FirstName() As String
            Get
                Return mFirstName
            End Get
            Set(ByVal Value As String)
                mFirstName = Value
            End Set
        End Property
        Public Property LastName() As String
            Get
                Return mLastName
            End Get
            Set(ByVal Value As String)
                mLastName = Value
            End Set
        End Property
        Public Property MiddleInitial() As String
            Get
                Return mMiddleInitial
            End Get
            Set(ByVal Value As String)
                mMiddleInitial = Value
            End Set
        End Property
        Public Property Address() As String
            Get
                Return mAddress
            End Get
            Set(ByVal Value As String)
                mAddress = Value
            End Set
        End Property
        Public Property Apartment() As String
            Get
                Return mApartment
            End Get
            Set(ByVal Value As String)
                mApartment = Value
            End Set
        End Property
        Public Property City() As String
            Get
                Return mCity
            End Get
            Set(ByVal Value As String)
                mCity = Value
            End Set
        End Property
        Public Property State() As String
            Get
                Return mState
            End Get
            Set(ByVal Value As String)
                mState = Value
            End Set
        End Property
        Public Property Zip() As String
            Get
                Return mZip
            End Get
            Set(ByVal Value As String)
                mZip = Value
            End Set
        End Property
        Public Property Country() As String
            Get
                Return mCountry
            End Get
            Set(ByVal Value As String)
                mCountry = Value
            End Set
        End Property
        Public Property DaytimePhone() As String
            Get
                Return mDaytimePhone
            End Get
            Set(ByVal Value As String)
                mDaytimePhone = Value
            End Set
        End Property
        Public Property EmailAddress() As String
            Get
                Return mEmailAddress
            End Get
            Set(ByVal Value As String)
                mEmailAddress = Value
            End Set
        End Property
        Public Property GiftAmount() As String
            Get
                Return mGiftAmount
            End Get
            Set(ByVal Value As String)
                mGiftAmount = Value
            End Set
        End Property
        Public Property DataComplete() As Boolean
            Get
                Return mDataComplete
            End Get
            Set(ByVal Value As Boolean)
                mDataComplete = Value
            End Set
        End Property
        Public Property AccountNumber() As String
            Get
                Return mAccountNumber
            End Get
            Set(ByVal Value As String)
                mAccountNumber = Value
            End Set
        End Property
        Public Property CreditCard() As String
            Get
                Return mCreditCard
            End Get
            Set(ByVal Value As String)
                mCreditCard = Value
            End Set
        End Property
        Public Property ExpDateMonth() As Integer
            Get
                Return mExpDateMonth
            End Get
            Set(ByVal Value As Integer)
                mExpDateMonth = Value
            End Set
        End Property
        Public Property ExpDateYear() As Integer
            Get
                Return mExpDateYear
            End Get
            Set(ByVal Value As Integer)
                mExpDateYear = Value
            End Set
        End Property

        Public Property LastUpdateDate() As String
            Get
                Return mLastUpdateDate
            End Get
            Set(ByVal Value As String)
                mLastUpdateDate = Value
            End Set
        End Property
#End Region

#Region "Constructors"
        Public Sub New()

        End Sub
        Public Sub New(ByVal prospectId As Integer)
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            mId = prospectId

            strSQL = "SELECT * FROM Prospect WHERE Id=" & mId
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then Return

            r = ds.Tables(0).Rows(0)

            If Not r("FirstName") Is DBNull.Value Then
                mFirstName = r("FirstName")
            End If
            If Not r("LastName") Is DBNull.Value Then
                mLastName = r("LastName")
            End If
            If Not r("MiddleInitial") Is DBNull.Value Then
                mMiddleInitial = r("MiddleInitial")
            End If
            If Not r("Address") Is DBNull.Value Then
                mAddress = r("Address")
            End If
            If Not r("Apartment") Is DBNull.Value Then
                mApartment = r("Apartment")
            End If
            If Not r("City") Is DBNull.Value Then
                mCity = r("City")
            End If
            If Not r("State") Is DBNull.Value Then
                mState = r("State")
            End If

            If Not r("Zip") Is DBNull.Value Then
                mZip = r("Zip")
            End If
            If Not r("Country") Is DBNull.Value Then
                mCountry = r("Country")
            End If
            If Not r("DaytimePhone") Is DBNull.Value Then
                mDaytimePhone = r("DaytimePhone")
            End If
            If Not r("EmailAddress") Is DBNull.Value Then
                mEmailAddress = r("EmailAddress")
            End If
            If Not r("GiftAmount") Is DBNull.Value Then
                mGiftAmount = r("GiftAmount")
            End If
            If Not r("DataComplete") Is DBNull.Value Then
                DataComplete = CBool(r("DataComplete"))
            End If
            If Not r("AccountNumber") Is DBNull.Value Then
                mAccountNumber = r("AccountNumber")
            End If
            If Not r("CreditCard") Is DBNull.Value Then
                mCreditCard = r("CreditCard")
            End If
            If Not r("ExpDateMonth") Is DBNull.Value Then
                mExpDateMonth = r("ExpDateMonth")
            End If
            If Not r("ExpDateYear") Is DBNull.Value Then
                mExpDateYear = r("ExpDateYear")
            End If
            If Not r("LastUpdateDate") Is DBNull.Value Then
                mLastUpdateDate = r("LastUpdateDate")
            End If

        End Sub

#End Region

#Region "Public Methods"
        Public Function GetProspectList() As ArrayList
            Dim strSQL As String
            Dim ds As DataSet
            Dim r As DataRow

            Dim prospectArray As New ArrayList

            strSQL = "SELECT * FROM Prospect order by LastName, FirstName"
            ds = SqlHelper.ExecuteDataset(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            If ds.Tables(0).Rows.Count = 0 Then
                Return prospectArray
            End If

            For Each r In ds.Tables(0).Rows
                Dim s As New Prospect(r("Id"))
                prospectArray.Add(s)
            Next r
            Return prospectArray

        End Function

        Public Function Save() As Boolean
            Try
                If mId > 0 Then
                    Return Update()
                Else : Return Insert()
                End If
            Catch ex As Exception
                Throw ex
            End Try
        End Function

        Public Function Delete() As Boolean
            Try
                Dim strSQL As String
                Dim ds As DataSet
                Dim r As DataRow

                strSQL = "Delete FROM Prospect " & _
                    "WHERE Id=" & mId

                Return 0 < SqlHelper.ExecuteNonQuery(DataConnHelper.getStrConn, CommandType.Text, strSQL)
            Catch ex As Exception
                Throw ex
            End Try

        End Function


#End Region

#Region "Private Methods"
        Private Function Update() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_UpdateProspect", _
            mId, _
            mFirstName, _
            mLastName, _
            mMiddleInitial, _
            mAddress, _
            mApartment, _
            mCity, _
            mState, _
            mZip, _
            mCountry, _
            mDaytimePhone, _
            mEmailAddress, _
            mGiftAmount, _
            mDataComplete, _
            mAccountNumber, _
            mCreditCard, _
            mExpDateMonth, _
            mExpDateYear, _
            CDate(mLastUpdateDate))

            Return True
        End Function
        Private Function Insert() As Boolean
            Dim result As Integer

            result = SqlHelper.ExecuteScalar(DataConnHelper.getStrConn, _
            "sp_AddProspect", _
            mFirstName, _
            mLastName, _
            mMiddleInitial, _
            mAddress, _
            mApartment, _
            mCity, _
            mState, _
            mZip, _
            mCountry, _
            mDaytimePhone, _
            mEmailAddress, _
            mGiftAmount, _
            mDataComplete, _
            mAccountNumber, _
            mCreditCard, _
            mExpDateMonth, _
            mExpDateYear, _
            CDate(mLastUpdateDate))
            If result > 0 Then
                mId = result
                Return True
            Else : Return False
            End If
        End Function

#End Region

    End Class
End Namespace
