/*
'******************************************************************************
' FileName: comp_control.cs
' Author:   VL, HS, RS
' Created:  Nov-2003
' This class serves as the build time control text generator.
' pwhcomp will use this to discover what to write to the CB_EX* pages.
'*****************************************************************************
*/

using System;
using System.Collections;
using System.Collections.Specialized;

namespace pwhcomp
{
	public class comp_control
	{

		// HandleControlBuilderTag
		// This method will handle the PWH: tags and write the appropriate text
		// necessary to have the "glued" file processable.
		public string HandleControlBuilderTag(string cd_txt)
		{
			string newtext = cd_txt;
			// Rule 1
			// Look for the first >
			int control_type = cd_txt.IndexOf(" ",0,cd_txt.Length);
			string s_control_type = cd_txt.Substring(0,control_type);

			//Rule 2
			//NVP's are after TYPE until first >
			int start_props = control_type+1;
			int end_props = cd_txt.IndexOf(">",start_props);

			// Rule 3
			//Develop NVPs
			//These are anything that has a <space>...=...<space>
			bool eop = false;
			int i_start_props = start_props;
			int i_end_props = end_props;
			string s_props = cd_txt.Substring(i_start_props,i_end_props-i_start_props);
			NameValueCollection nvp=new NameValueCollection();

			
			string [] prop_split = s_props.Split(new Char [] {' '});
			string [] split = s_props.Split(new Char [] {'='});

				
			bool is_value = false;	
			string nm = "";
			string va = "";

			foreach (string s1 in prop_split)
			{
				split = s1.Split(new Char [] {'='});
				foreach (string s in split) 
				{
					if (!is_value)
					{
						nm = s.Trim();						
						is_value = true;
					}
					else
					{
						// Check to see if there are some things that we need to rid of					
						
						va = s.Replace('\"',' ');
						va = va.Trim();
						is_value=false;
						// can push
						nvp.Add(nm,va);
					}
				}
			}

			if (s_control_type=="HTMLCTRL")
			{
				// Properties of the HTMLCTRL control are as follows:
				// For a HTMLCTRL, lets note that anything can be the value.
				string txt = cd_txt.Substring(end_props+1,cd_txt.IndexOf("</PWH>")-(end_props+1));
				if (txt.Length>0)
					nvp["value"]=txt;				
				newtext = "\r\nHtmlControl " +  nvp["ID"] +"_lbl = new HtmlControl(); \r\n";
				newtext = newtext +  nvp["ID"] +"_lbl.ControlText=\"" + nvp["value"] + "\";\r\n";
				newtext = newtext + "\r\nResponse.Advise(\"" +nvp["ID"] +"_lbl\"," + nvp["ID"]+ "_lbl);\r\n";

			}
			
			return newtext;
		}

		//compiler_generatecode
		//This method will provide the code necessary to render the control
		public string compiler_generatecode(string cd_txt)
		{
			string newtext = cd_txt;
			// Rule 1
			// Look for the first >
			int control_type = cd_txt.IndexOf(" ",0,cd_txt.Length);
			string s_control_type = cd_txt.Substring(0,control_type);

			//Rule 2
			//NVP's are after TYPE until first >
			int start_props = control_type+1;
			int end_props = cd_txt.IndexOf(">",start_props);

			// Rule 3
			//Develop NVPs
			//These are anything that has a <space>...=...<space>
			bool eop = false;
			int i_start_props = start_props;
			int i_end_props = end_props;
			string s_props = cd_txt.Substring(i_start_props,i_end_props-i_start_props);
			NameValueCollection nvp=new NameValueCollection();

			
				string [] prop_split = s_props.Split(new Char [] {' '});
				string [] split = s_props.Split(new Char [] {'='});

				
				bool is_value = false;	
				string nm = "";
				string va = "";

			foreach (string s1 in prop_split)
			{
				split = s1.Split(new Char [] {'='});
				foreach (string s in split) 
				{
					if (!is_value)
					{
						nm = s.Trim();						
						is_value = true;
					}
					else
					{
						// Check to see if there are some things that we need to rid of											
						va = s.Replace('\"',' ');
						va = va.Trim();
						is_value=false;
						// can push
						nvp.Add(nm,va);
					}
				}
			}
			if (s_control_type=="HTMLCTRL")
			{
				// Properties of the label control are as follows:
				// For a label, lets note that anything can be the value.
				string txt = cd_txt.Substring(end_props+1,cd_txt.IndexOf("</PWH>")-(end_props+1));
				if (txt.Length>0)
					nvp["value"]=txt;
				// Ok now lets insert some code
				//newtext = nvp["value"];
				newtext = "\r\nResponse.Write (" +nvp["ID"] +"_lbl.RenderControl()" +");\r\n";
				
			
			}


		return newtext;
		}
	}
}
