/*
'******************************************************************************
' FileName: Resource.cs
' Author:   VL, HS, RS
' Created:  Nov-2003
' This class serves as a basic port listener to enable HTTP capabilities.
'*****************************************************************************
*/

using System;
using System.Data;
using System.Reflection;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace pwhost
{
	// prtdriver
	class pwhdriver
	{
		public class Server : MarshalByRefObject
		{
			private TcpListener serverListener;
			private int port;
			private TcpClient client;
			private string physicalDirectory;


			public Server()
			{
			}

			public void start(int port, string physicalDirectory)
			{
				this.port = port;
				this.physicalDirectory = physicalDirectory;
				Thread th = new Thread(new ThreadStart(startListen));
				th.Start();
			}

			 
			public void startListen()
			{
				try
				{
					serverListener = new TcpListener(port);
					serverListener.Start();
					do
					{
						client = serverListener.AcceptTcpClient();						
						ProcessRequest(client);
					}
					while(true);
				}
				catch
				{
					serverListener.Stop();
				}
			}

			
			public void ProcessRequest(TcpClient client) 
			{
				try
				{
					WorkerThread newClient = new WorkerThread(client, physicalDirectory);
				}
				catch (Exception ex)
				{
					
				}

			}
     
			// ByteToString
			// Simple way to convert Byte datatyoes to a String.
			public static string ByteToString(Byte[] array)
			{
				string result = "";

				for(int i=0;i<array.Length;i++)
				{
					char b = (char)array[i];
					if (array[i]==0)
						return result;
					result+=b;
				}
				return result;
			}


			public static Byte[] StringToByte(string array)
			{
				return System.Text.Encoding.ASCII.GetBytes(array);
			}
			public static void exit()
			{				
				exit();				
			}

			

			//
			// Main
			// ----
			// This is the main entry point in the class and is that start point of the server.
			public static void Main(String[] args) 
			{
				string physicalDirectory = "";
				int port = 8080;

				Server server = new Server();
				server.start(port, physicalDirectory);
			}
		}
		
	}
}