/*
'******************************************************************************
' FileName: Resource.cs
' Author:   VL, HS, RS
' Created:  Nov-2003
' This class houses the basic data resources. 
'*****************************************************************************
*/

using System;
using System.IO;
using System.Xml;


namespace pwhost
{
	
	public class Resource : MarshalByRefObject
	{
		private string filename;
		private string extension;
		private string mimetype;
		private string physicalLocation;
		private string queryData;

		public Resource(string physicalLocation, string filename)
		{
			this.filename = filename;
			extension = filename.Substring(filename.IndexOf("."),(filename.Length-filename.IndexOf(".")));
			mimetype = MimeType.getMimeType(extension);
			this.physicalLocation = physicalLocation;
		}

		public string getMimeType()
		{
			return this.mimetype;
		}

		public string getFilename()
		{
			return this.filename;
		}

		public string getPhysicalLocation()
		{
			return this.physicalLocation;
		}

		public string getExtension()
		{
			return this.extension;
		}

		public bool requiresPreProcessing()
		{
			if ((getExtension()==".aspx") || (getExtension()==".asp") || (getExtension()==".html") || (getExtension()==".htm"))
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		public string getQueryData()
		{
			return this.queryData;
		}

		public void setQueryData(string data)
		{
			queryData = data;
		}
	}
}
